### Name: getColorMap.ggobi
### Title: Set or query the colormap for a ggobi instance.
### Aliases: getColorMap.ggobi setColorMap.ggobi
### Keywords: visualization interactive graphics

### ** Examples

  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  g$getColorMap()
  names(g$getColorMap())
  
    # register a new color map with only 3 entries - Red, Green and Blue.
    # Then convert the colors' of the points to these values.
  cm <- diag(3)
  rownames(cm) <- c("R", "G","B")
  g$setColorMap(cm)

## Not run: 
##D   m["green", 1] <- .5
##D   g$setColorMap(m)
##D   g$setColors(rep("green", 20))
## End(Not run)

## Not run: 
##D   # Copy a colormap from one ggobi to another
##D  g1 <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
##D  g2 <- ggobi(system.file("data", "sat.xml", package="Rggobi"), args="-noinit")
##D  g2$setColorMap(g1$getColorMap())
## End(Not run)



