### Name: getDatasetReference
### Title: Get an object representing an internal ggobi dataset
### Aliases: getDatasetReference getDatasetReference.ggobi
###   getDatasetReference.ggobiDisplay
###   getDatasetReference.ggobiDisplayDescription getDisplayDataset.ggobi
### Keywords: visualization interactive graphics

### ** Examples

  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  g$setData(system.file("data", "sat.xml", package="Rggobi"))

  g[1]
  g["flea"]

  g["SAT scores"]

   # Get reference by index
  g$getDatasetReference(1)
   # by name
  g$getDatasetReference("flea")

   # get it from a ggobiDisplayDescription object
  d <- g$getDisplays(T)[[1]]
  getDatasetReference(d)

   # get it from a ggobiDisplay object
  d <- g$getDisplays()[[1]]
  getDatasetReference(d)



