\name{addVariable.ggobi}
\alias{addVariable.ggobi}
\alias{removeVariable.ggobi}
\title{Add or remove a variable from a ggobi dataset.}
\description{
 These currently do not work very well!
}
\usage{
addVariable.ggobi(vals, name, .data = 1, .gobi=getDefaultGGobi())
removeVariable.ggobi(..., .data = 1, .gobi=getDefaultGGobi())
}
\arguments{
  \item{vals}{a numeric vector containing the values of the new variable.}
  \item{name}{a name for the new variable.}
  \item{\dots}{identifiers for the variables which are to be removed from the
       dataset}
  \item{.data}{an identifier for the ggobi dataset to which variables are to be added
     or from which they are to be removed. This can be a name, an object
    of class \code{ggobiDataset} or an integer.}
  \item{.gobi}{an identifier for the ggobi instance in which to find the dataset.
    This should  be an object of class \code{ggobi}, or an integer.}
}
\details{
  These need a little more work in the ggobi library.
}
\value{
 A logical value indicating whether the operation was successful or not.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}


\seealso{
\code{\link{setVariableValues.ggobi}}
}

\examples{

}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{setBrushColor.ggobi}
\alias{setBrushColor.ggobi}
\alias{getBrushColor.ggobi}
\alias{getBrushGlyph.ggobi}
\alias{setBrushGlyph.ggobi}
\title{Set or retrieve the settings for the appearance of a ggobi brush}
\description{
 The appearance of the ``brush'' -- the  control for the selection
 of points or a region -- can be manipulated per ggobi
 instance. These functions control the color of 
 the brush region and the points within it,
  and also the glyph used to display the selected points within
 this region.
}
\usage{
setBrushColor.ggobi(id, .gobi=getDefaultGGobi())
getBrushColor.ggobi(.gobi=getDefaultGGobi())
setBrushGlyph.ggobi(type, size, .gobi=getDefaultGGobi())
getBrushGlyph.ggobi(.gobi=getDefaultGGobi())
}
\arguments{
  \item{id}{the identifier for the color to which the corresponding
   value of the brush region is to be set. For a color, this can be either a name
   (as in the row names from \code{getColorMap.ggobi} or an integer identifying
   the particular row/entry of the color map.}
  \item{type}{the identifier of the glyph}
  \item{size}{an integer specifying the size to which the brush  glyph should be set.}
  \item{.gobi}{the ggobi identifier, either an object of class \code{ggobi}
   or an integer.}
}
\value{
 The \code{get} methods   return the current value for the attribute
 in effect at present.
 In the \code{set} methods, the value in effect before the  call
 is returned. This can be used to restore the original settings
 after some event.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{setBrushSize.ggobi}}
\code{\link{getBrushSize.ggobi}}
\code{\link{setBrushLocation.ggobi}}
\code{\link{getBrushLocation.ggobi}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")

##  g$setBrushColor("red")

  g$setMode("Brush")

  g$setBrushGlyph("plus")
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{setBrushLocation.ggobi}
\alias{setBrushSize.ggobi}
\alias{getBrushSize.ggobi}
\alias{setBrushLocation.ggobi}
\alias{getBrushLocation.ggobi}
\title{Gets or sets the location and/or dimension of the selection region
       of a ggobi dataset.}
\description{
 This  allows the user to query and set the location and 
 size of the brushing region of a ggobi dataset.
}
\usage{
setBrushLocation.ggobi(x, y, .data = 1, .gobi=getDefaultGGobi(), update=T, units=0)
getBrushLocation.ggobi(.data = 1, .gobi=getDefaultGGobi(), units=0)
setBrushSize.ggobi(w, h, .data=1, .gobi=getDefaultGGobi(), update = T, units=0)
getBrushSize.ggobi(.data=1, .gobi=getDefaultGGobi(), units=0)
}
\arguments{
  \item{x}{the x coordinate at which to locate the brushing region (in pixels)}
  \item{y}{the x coordinate at which to locate the brushing region (in pixels)}
  \item{w}{the width to which to set the brushing region (in pixels)}
  \item{h}{the height to which to set the brushing region (in pixels)}
  \item{.data}{the dataset identifier for which the brush should be set or queried.
 This can be a simple index or an object of class \code{ggobiDataset}.
If the latter is set, no value for \code{.gobi} need be specified.}
  \item{.gobi}{the identifier for the ggobi instance in which the 
 dataset can be resolved. This can be either an index identifying
the ggobi instance by order, or an object of class \code{ggobi} 
returned from a call to \code{\link{ggobi}} or \code{\link{getGGobi}}.}
  \item{update}{whether to force the recomputation of the points within 
 the brushing region and the updating of the display giving the number of points
 within this region. This is often supressed when changing both location and size
 in two separate actions.}
  \item{units}{currently ignored, but will allow specification of what units}
}
\details{
}
\value{
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\note{ The settings are in pixel coordinates relative to the plot and
not the coordinates of the data being plotted.  In the future, we will
provide functions to map between these different units.}


\seealso{
\code{\link{getSelectedIndices.ggobi}}
\code{\link{getBrushColor.ggobi}}
\code{\link{setBrushColor.ggobi}}
\code{\link{getBrushGlyph.ggobi}}
\code{\link{setBrushGlyph.ggobi}}
}

\examples{
 g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
 g$setMode("Brush"); 
 g$setBrushLocation(50, 50); 
 g$setBrushSize(100, 50); 
 g$getSelectedIndices()
}
\keyword{visualization}
\keyword{interactive graphics}



\eof
\name{setColors.ggobi}
\alias{setColors.ggobi}
\alias{getColors.ggobi}
\alias{setLineSegments.ggobi}
\alias{setHiddenCases.ggobi}
\alias{getLineSegments.ggobi}
\alias{getHiddenCases.ggobi}

\title{Access color and hidden attributes of records.}
\description{
}
\usage{
setColors.ggobi(colors, which = 1:length(colors), .data=1, .gobi=getDefaultGGobi())
getColors.ggobi(which, .data=1, .gobi=getDefaultGGobi())
setHiddenCases.ggobi(vals, which = 1:length(vals), .data = 1, .gobi=getDefaultGGobi())
getHiddenCases.ggobi(.data = 1, .gobi=getDefaultGGobi())
}
\arguments{
  \item{colors}{color identifiers, either indices into the color map,
   or names of entries in the color map.}
  \item{vals}{logical vector giving the settings for the records
   identified in the parallel vector of indices \code{which}.}
  \item{which}{the indices of the records for which the color
  should be set. This vector is used in parallel with the \code{colors}
  argument. The i-th element of colors is applied to the record
  identified by the i-the element of \code{which}.}
  \item{.data}{the identifier for the dataset whose records are to be 
  set or queried. This can be an integer, name/string or an object of
  class \code{ggobiDataset}.} 
  \item{.gobi}{the ggobi instance identifier. This is used to resolve the
  dataset and is unecessary if an object of class  \code{ggobiDataset} is 
  supplied for the \code{.data} argument.}
}
\value{

}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{getGlyphs.ggobi}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  g$getColors()
  g$setColors(rep(2, 74), which=1:nrow(g[1]))

   # now highlight a subset of the points
  g$setColors(rep(1, 74), which=1:32)

\dontrun{
# Update
   # Set the first 30 records to blue.
  g$setColors(rep("blue",30))  # no colornames for the moment

   # Set the colormap and then set the 
   # points.
  m <- g$getColorMap()
  m["green", 1] <- .5
  g$setColorMap(m)
  g$setColors(rep("green",30))
}
}
\keyword{iplot}
\keyword{dynamic}

\eof
\name{getColorMap.ggobi}
\alias{getColorMap.ggobi}
\alias{setColorMap.ggobi}
\title{Set or query the colormap for a ggobi instance.}
\description{
 These functions allow one to retrieve or set the contents
of the color map used by a ggobi instance.
The color map is an $n \times 3$ matrix of
of which each row contains the 
Red, Green and Blue values defining a color.
Some colors have names and others are referenced
simply by index in the colormap.
}
\usage{
getColorMap.ggobi(.gobi=getDefaultGGobi())
setColorMap.ggobi(vals, .gobi=getDefaultGGobi(), scale = 65535)
}
\arguments{
  \item{vals}{an $n$ by $3$ matrix giving the entries in the colormap
   in terms of their Red, Green and Blue components. The columns of the matrix
  should be in that order.}
  \item{.gobi}{an identifier for the ggobi instance whose color map is
to be set or retrieved. This is either an integer or an object
of class \code{ggobi}.}
  \item{scale}{a scaling factor by which the elements of the matrix
   are multiplied to convert them to internal format for use with Gtk.}
}
\details{
  These functions convert the internal representation in
ggobi of a colormap to an R matrix and vice-versa.
}
\value{
 \code{getColorMap.ggobi} returns a matrix of 
dimension $n \times 3$ containing the Red, Green and Blue values
with each element being between  $0$ and $1$.
The row names are those stored in the ggobi colormap, if supplied
when reading the color map,
or otherwise the index (starting at $1$).

 \code{setColorMap} 
}
\references{\url{http://www.ggobi.org/RSggobi.html}}
\author{Duncan Temple Lang}


\note{
 Currently, when operating on the colormap, one must operate on all of
it, rather than operating on individual elements.  In other words, one
has to copy it all into R, modify the values and then transfer it back
to ggobi.  Since colormaps are reasonably small, can be specified in
files and change infrequently, this is not a large penalty.  }

\seealso{
\code{\link{getColors.ggobi}}
\code{\link{setColors.ggobi}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  g$getColorMap()
  names(g$getColorMap())
  
    # register a new color map with only 3 entries - Red, Green and Blue.
    # Then convert the colors' of the points to these values.
  cm <- diag(3)
  rownames(cm) <- c("R", "G","B")
  g$setColorMap(cm)

\dontrun{
  m["green", 1] <- .5
  g$setColorMap(m)
  g$setColors(rep("green", 20))
}

\dontrun{
  # Copy a colormap from one ggobi to another
 g1 <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
 g2 <- ggobi(system.file("data", "sat.xml", package="Rggobi"), args="-noinit")
 g2$setColorMap(g1$getColorMap())
}
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{names.ggobiDataset}
\alias{names.ggobiDataset}
\title{Methods for ggobiDataset objects}
\description{
 Return the names of the datasets within a ggobi instance.
}
\usage{
names.ggobi(x)
}
\arguments{
  \item{x}{the object of class \code{ggobiDataset}}
}
\details{
}
\value{
 These behave like their counterparts
that operate on data frames or matrices.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
 \code{\link{[.ggobi}}
 \code{\link{getDatasetReference.ggobi}}
 \code{\link{describe.ggobi}}
 \code{\link{names.ggobi}}
}

\examples{
 g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")

 names(g)
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{[.ggobiDataset}
\alias{[.ggobiDataset}
\alias{[<-.ggobiDataset}
\alias{[[<-.ggobiDataset}
\title{Subsetting extraction and assignments for ggobi datasets}
\description{
These functions/methods allow one to treat
a ggobi dataset as if it were a local matrix/data.frame.
One can extract and assign elements within the 
dataset.
There is a fundamental difference between
the two assignment operators (\code{[<-} and \code{[[<-}).
  The \code{[<-} operator first retrieves all the data
  from the GGobi dataset, does the replacement using R's
  semantics and then resets the data.
  \code{[[<-} attempts directly replaces
  the value(s) specified by the index d
  within the GGobi. This is much more efficient
  as it avoids copying all the data.
  However, the semantics are not the same as the
  usual R subsetting. This is currently intended
  for changing individual points and support for
  vector indices will probably change.
}
\usage{
"[.ggobiDataset"(x, ..., drop=F)
"[<-.ggobiDataset"(x, i, j, value)
"[[<-.ggobiDataset"(x, i, j, value)
}
\arguments{
  \item{x}{the \code{ggobiDataset} object}
  \item{drop}{the drop argument as in the regular 
      matrix and data frame subsetting functions.
     This is passed to the relevant subset operation when the data is transferred.}
  \item{\dots}{the indices by which to subset the dataset}
  \item{i}{the indices for selecting the rows of the matrix to which
    the values are to be assigned.}
  \item{j}{the indices for selecting the columns of the matrix to which
    the values are to be assigned.}
  \item{value}{the values to assigned to the elements of the matrix.}
}
\details{
 At present, the assignment is unecessarily expensive
in that it transfers the entire dataset from 
ggobi, performs the usual subsetting operations
and then transfers the results back into the
variables of the original dataset.
This can be made smarter.
}
\value{
 The subsetting operator \code{[}
 returns the result of subsetting the
 matrix corresponding to the ggobi dataset.
 This is identical to the functionality of the
 subsetting of a matrix.

 The assignment operator \code{[<-}
 returns the original \code{ggobiDataset} 
 object. The side-effect is to modify the
 contents of the internal ggobi dataset.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
  \code{\link{setVariableValues.ggobi}}
  \code{\link{getVariable.ggobi}}
  \code{\link{getData.ggobi}}
  \code{\link{names.ggobiDataset}}
  \code{\link{dimnames.ggobiDataset}}
}

\examples{
 g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
 d <- g[[1]]
 d[1,1] <- 100
# d[[1,1]] <- 100
  # 
 g$getData()[1,1]

 d[1:3,1:2] <- .3
 d[1:3,1:2]
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getDatasetNames.ggobi}
\alias{getDatasetNames.ggobi}
\alias{datasetIndex.ggobi}
\title{Get the names or index of the datasets in a ggobi instance}
\description{
 The \code{getDatasetNames.ggobi} is a method for 
 obtaining the names of the different datasets 
 within a ggobi instance. Occassionally it is also
 useful to map the name  of one of these datasets
 to is position or index.

 \code{datasetIndex.ggobi}
 does this, but it is used infrequently given the
 introduction of the \code{ggobiDataset} class
 and methods (e.g. \code{\link{getDatasetReference.ggobi}})
 for obtaining references to datasets
 that are position/order invariant. This is also a
 function that is typically used by other functions
 in the package and not directly called by users of the package.
}
\usage{
getDatasetNames.ggobi(.gobi=getDefaultGGobi())
datasetIndex.ggobi(.data, .gobi=getDefaultGGobi())
}
\arguments{
  \item{.data}{the names of one or more dataset whose indices are to be determined.}
  \item{.gobi}{the identifier for the ggobi instance whose datasets are to be queried.
  This should be an object of class \code{ggobi} or else an integer identifying
  the ggobi instance by position in the list of all ggobis.}
}
\details{
 The name of a dataset is defined in a variety of different
ways depending on the format of the input file, data, etc.
}
\value{
 \code{getDatasetNames.ggobi} returns a character vector
containing the names of the datasets.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}


\seealso{
\code{\link{names.ggobi}}
\code{\link{getDatasetReference.ggobi}}
}

\examples{
   g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
   names(g)
   getDatasetNames.ggobi(g)
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{dim.ggobiDataset}
\alias{dim.ggobiDataset}
\alias{dimnames.ggobiDataset}
\alias{ncol.ggobiDataset}
\alias{nrow.ggobiDataset}
\title{Accessors for GGobi Dataset}
\description{

}
\usage{
dim.ggobiDataset(d)
dimnames.ggobiDataset(d)
nrow.ggobiDataset(d)
ncol.ggobiDataset(d)
}

\arguments{
  \item{d}{the dataset reference}
}
\details{
  These are methods that 
}
\value{
  \code{nrow} and \code{ncol} return the
  number of records and variables respectively in the
  GGobi dataset.
  \code{dim} returns (\code{nrow(d)}, \code{ncol(d)}).
  And \code{dimnames} returns a list of length 2
  containing the row labels and the variable names
  respectively for the dataset.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{[[.ggobi}}
\code{\link{[.ggobi}}
}

\examples{
  data(mtcars)
  g <- ggobi(mtcars, args = "-noinit")
  dim(g[[1]])
  nrow(g[[1]])
  ncol(g[[1]])
}
\keyword{graphics}


\eof
\name{.GGobiCall}
\alias{.GGobiCall}
\alias{.GGobiC}
\alias{.ggobi.symbol}
\title{Wrappers for calling C routines in the R-ggobi library.}
\description{
 The \code{.ggobi.symbol} function is used entirely within R to 
map the given name to the name of the corresponding
C routine.
 The other two functions -- \code{.GGobiC} and \code{.GGobiCall} --
 convert the name and then call their C invocation counterparts.

 These functions map the simple name of a C routine into the
package-specific version of that name.  These allow use to hide the
use a name \textit{mangling} scheme of our choosing for the C level
routines in the shared library/DLL that provides the glue between R
and ggobi.  This is useful for avoiding name conflicts with other C
code in R or other packages.  These are only of relevance to the
developers of this package and those working with its C code.

}
\usage{
.GGobiCall(name, ..., .gobi=getDefaultGGobi())
.GGobiC(name, ..., .gobi=getDefaultGGobi())
.ggobi.symbol(name)
}
\arguments{
  \item{name}{the simple name of the C routine to be resolved}
  \item{\dots}{the arguments that to be passed to the \code{\link{.C}} or \code{\link{.Call}}}
  \item{.gobi}{the ggobi instance identifier that is to be passed to the C routine as its last
       argument. Specifying this here helps to ensure it is not omitted.}
}
\details{
 The mapping of the name to its corresponding C routine name
is done in conjunction with the pre-processor macro
\code{RS_GGOBI}. These  must be synchronized.
}
\value{
 \code{.ggobi.symbol} returns the name of the C routine
corresponding to its argument.

  The \code{.GGobiC} and \code{.GGobiCall} functions invoke the C
routine corresponding to the specified name and return the same result
as the corresponding \code{.C} and \code{.Call} do.

}

\references{\url{http://www.ggobi.org/RSggobi.html}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{.C}}
\code{\link{.Call}}
}


\examples{

}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{[.ggobi}
\alias{[.ggobi}
\alias{[[.ggobi}
\title{Obtains a reference to a ggobi dataset}
\description{
 This is a convenient syntax for referring to one or more
 datasets within a ggobi instance, either by index or by
 name.
 \code{[} operator returns a list of one or more objects of class
 \code{ggobiDataset},
 while \code{[[} is used to access a single dataset.
 These \code{ggobiDataset} objects can be used to refer to the dataset in the ggobi
 instance and the preferred type for the
 \code{.data} argument in most functions in the GGobi package.
  
}
\usage{
"[.ggobi"(x, ..., drop=F)
"[[.ggobi"(x, ..., drop=F)
}
\arguments{
  \item{x}{the object of class \code{ggobi}}
  \item{\dots}{the identifiers for the datasets within the ggobi instance.}
  \item{drop}{}
}
\value{
 One or more objects of class \code{ggobiDataset}.
 These are opaque references to internal C structures
 and should not be operated on directly. Instead, one
 should use the functions and methods that operate on objects
 of this class.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{names.ggobi}}
\code{\link{names.ggobiDataset}}
\code{\link{dim.ggobiDataset}}
\code{\link{dimnames.ggobiDataset}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  g[1]

  names(g)
  g["flea"]

  dim(g[1])
  g$setData(system.file("data", "sat.xml", package="Rggobi"))
  g[2]
  g["SAT scores"]
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{gdk.flush}
\alias{gdk.flush}
\title{Cause pending Gtk GUI events to be processed}
\description{
 Because of the interaction with the R event loop (reading use input),
on occassion, the changes caused by certain R functions that operate
on the the ggobi GUI are not displayed immediately. This function
allows the R programmer to try to force these changes to be displayed.
}
\usage{
gdk.flush()
}
\details{
  This flushes the Gtk events pending and forces them to be
 sent to the event queue and hopefully invoke the 
 low Gtk handler in R's event loop.
}
\value{
 No value.
}
\references{\url{http://www.ggobi.org/RSggobi.html}}
\author{Duncan Temple Lang}


\examples{
  g <- ggobi(system.file("data", "flea",package="Rggobi"), args="-noinit")
  g$scatmat(1:3)
  gdk.flush()
}
\keyword{event loop}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{addNumberedKeyHandler.ggobi}
\alias{addNumberedKeyHandler.ggobi}
\alias{.GetNumberedKeyHandler.ggobi}
\alias{registerNumberedKeyHandler.ggobi}
\alias{NumberedKeyHandler.ggobi}
\title{S Events for GGobi Keys}
\description{
  These functions allow one to set, query and manage
  a collection of event handlers that are triggered
  when the GGobi user hits a function key (i.e. F1,\dots, F12).
  This provides users with a simple way to have repeated actions
  occur at their control and can be used to, for example,
  print results after brushing numerous values, moving multiple points,
  etc. See the RGGobi manual for more examples.
}
\usage{
addNumberedKeyHandler.ggobi(..., .gobi=getDefaultGGobi())
.GetNumberedKeyHandler.ggobi(create=F, register=T, .gobi=getDefaultGGobi())
registerNumberedKeyHandler.ggobi(handler=NumberedKeyHandler.ggobi(), .gobi=getDefaultGGobi(), description="R numbered key press event handler")
NumberedKeyHandler.ggobi(...)
}
\arguments{
  \item{...}{}
  \item{.gobi}{}
  \item{create}{ }
  \item{register}{ }
  \item{handler}{}
  \item{description}{}
}
\details{

}
\value{
  ~Describe the value returned
  If it is a LIST, use
  \item{comp1 }{Description of `comp1'}
  \item{comp2 }{Description of `comp2'}
  ...
}
\references{
http://www.ggobi.org
}
\author{
Duncan Temple Lang
}

\seealso{
}

\examples{
}
\keyword{dynamic}

\eof
\name{getMode.ggobi}
\alias{getMode.ggobi}
\alias{setMode.ggobi}
\title{Get or sets the operation mode for a ggobi instance.}
\description{
 A ggobi instance can be in one of several diffferent modes,
 each of which has different response to user inputs, different controls, etc.
 These methods allow one to determine the current mode and also programmatically
 set it.
}
\usage{
getMode.ggobi(.gobi=getDefaultGGobi())
setMode.ggobi(name, .gobi=getDefaultGGobi())
}
\arguments{
  \item{name}{the name of the mode, one of the values returned from
   \code{\link{getModeNames.ggobi}}, such as "Brush", "Identify", "Move Points".}
  \item{.gobi}{the ggobi instance identifer; either an integer index or \code{ggobi}
  reference.}
}
\details{
  This re-initializes the ggobi instance
 for this mode. No displays, plots, datasets,  etc. are 
 modified, just the state of the ggobi instance
 and th response to different user actions.
}
\value{
 The name of the current (in the case of \code{setMode.ggobi})
 or the previous setting of the operation mode.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{getModeNames.ggobi}}
}

\examples{
 g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
 g$setBrushLocation(50, 50); 
 g$setBrushSize(100, 50); 
  # Now, go into brushing mode.
 g$setMode("Brush"); 

  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  old <- g$getMode()
  g$setMode("Brush")
  which <- g$getSelectedIndices()
  g$setMode(old)
}
\keyword{visualization}
\keyword{interactive graphics}


\eof
\name{parallelCoordDescription}
\alias{parallelCoordDescription}
\alias{scatterplotDescription}
\alias{scatmatrixDescription}
\alias{ashDescription}
\alias{timeseriesDescription}
\title{Create a plot description or template for use in plotLayout()}
\description{
 When creating composite plots in a single display/window,
 one first creates a description of each of the sub-plots
(e.g. scatterplot, parallel coordinates plot, ash, etc.)
 and then pass these virtual plots to \code{\link{plotLayout}}
 to instantiate them and lay them out within the display.
 These functions create the virtual plots in the form
 of a description.
}
\usage{
parallelCoordDescription(..., .data = -1, .gobi=NULL)
scatterplotDescription(x, y, .data = -1, .gobi=NULL)
scatmatrixDescription(..., .data = -1, .gobi=NULL)
ashDescription(x, .data = -1, .gobi=NULL)
timeseriesDescription(..., .data = -1, .gobi = NULL)
}
\arguments{
  \item{x,y}{variables to be displayed in the plot, given as 
     as a name, index.}
  \item{\dots}{the names or indices of the variables
that are to be displayed in the plot.}
  \item{.gobi}{optional ggobi instance with respect to which
the variables will be resolved. This can be specified
when the plot description is realized (e.g. in a call to 
\code{\link{plotLayout}})}
  \item{.data}{the index or name of the dataset 
within the ggobi instance in which the variable
identifiers are to be resolved.
}
}
\details{
  These descriptions are templates for how to create a
plot in the future. The descriptions can be created
before any ggobi is created.
The idea here is similar to having an expression
generated by \code{\link{quote}} or \code{\link{expression}}
that is to be evaluated at a subsequent time.
}
\value{
A list containing the arguments and whose class identifies the plot
type corresponding to which of these description functions was
invoked.
}

\references{\url{http://www.ggobi.org}, \url{http://www.ggobi.org/Rggobi}}
\author{Duncan Temple Lang}


\seealso{
\code{\link{plotLayout}}
}

\examples{
  plot4 <- ashDescription("tars2")
  plot5 <- scatmatrixDescription("tars1", "tars2", "head")
  plot6 <- parallelCoordDescription("tars1", "tars2", "head")
}
\keyword{visualization}
\keyword{interface}

\eof
\name{getPlotCount.ggobi}
\alias{getPlotCount.ggobi}
\alias{getPlotType.ggobi}
\title{Query the number and types of plots in a ggobi display}
\description{
 These functions query the type of a ggobi display
 and the number of plots within it.
}
\usage{
getPlotCount.ggobi(display=1, .gobi=getDefaultGGobi())
getPlotType.ggobi(display=1, .gobi=getDefaultGGobi())
}
\arguments{
  \item{display}{}
  \item{.gobi}{}
}
\details{

}
\value{
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\getDisplays.ggobi}
\code{\getDisplayCount.ggobi}
\code{\link{scatmat.ggobi}}
\code{\link{parcoords.ggobi}}
\code{\link{scatterplot.ggobi}}
}

\examples{
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getRowGroups.ggobi}
\alias{getRowGroups.ggobi}
\alias{setRowGroups.ggobi}
\title{Sets or queries the groupings of observations in a ggobi dataset.}
\description{
 Records/observations in a ggobi dataset can be arranged
into groups rather than treated individually.
Then brushing a point in that group selects
all points in that group.
The groups are assigned by specifying a group
index (integers starting at 1)
for the different records.
These functions allow one to query and set the 
groups. 
}
\usage{
getRowGroups.ggobi(.data=1, .gobi=getDefaultGGobi())
setRowGroups.ggobi(ids, .data=1, .gobi=getDefaultGGobi())
}

\arguments{
  \item{ids}{ an integer vector giving the group identifiers
   for all the observations in the dataset.}
  \item{.data}{the dataset in question. This can be an object of 
   class \code{ggobiDataset}, a name that matches those returned
   from \code{getDatasetNames.ggobi} or an integer giving the
   dataset by index.}
  \item{.gobi}{an identifier for the ggobi instance in which to find
   the dataset. If \code{.data} is an object of class \code{ggobiDataset},
  this is not needed. Otherwise, it should be an object of class \code{ggobi}
   or an integer.}
}
\value{

}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}
\seealso{
 \code{\link{setColors.ggobi}}
 \code{\link{getColors.ggobi}}
 \code{\link{setGlyphs.ggobi}}
 \code{\link{getGlyphs.ggobi}}
}

\examples{

}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getSelectedIndices.ggobi}
\alias{getSelectedIndices.ggobi}
\alias{isObservationSelected.ggobi}
\title{Computes which records are selected in a ggobi instance}
\description{
  The user can select different records in a ggobi dataset
 using the brushing region.
  These functions provide two ways to query
 the set of selected observations.
  One (\code{getSelectedIndices.ggobi}) returns the indices of the selected records.
The other is a simple transformation of this information
which indicates, via a logical vector, for  each  record
whether it is currently selected.
}
\usage{
getSelectedIndices.ggobi(.data = 1, .gobi=getDefaultGGobi())
isObservationSelected.ggobi(.data = 1, .gobi=getDefaultGGobi())
}
\arguments{
  \item{.data}{the dataset whose selected status is to be queried.
  This can be any identifier for a dataset, specifically a name, index
or an object of class \code{ggobiDataset}.}
  \item{.gobi}{an identifier for the ggobi instance in which the dataset
to be queried resides. This is either an index or an object of class
\code{ggobi}. This is not necessary if the \code{.data} argument
is supplied in the form of an object of class \code{ggobiDataset}.}
}
\value{
\code{getSelectedIndices.ggobi} returns
an integer vector containing the indices of the records
in the specified dataset that are currently selected.

\code{isObservationSelected.ggobi}
returns  a logical vector the length of which is the number 
of records in the specified dataset and in which
each element indicates whether the corresponding record 
is currently selected.
}
\references{\url{http://www.ggobi.org/RSggobi.html}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{setBrushLocation.ggobi}}
\code{\link{setBrushSize.ggobi}}
\code{\link{getBrushLocation.ggobi}}
\code{\link{getBrushSize.ggobi}}
}

\examples{

}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{addColorScheme}
\alias{addColorScheme}
\title{Adds a color scheme to a GGobi instance or the global color
  scheme list.}
\description{
  This takes an R color scheme description and
  adds an equivalent representation to
  either the color schemes available to a particular GGobi instance
  or to the global list of color schemes within a GGobi session.
}
\usage{
addColorScheme(scheme, name, overwrite=FALSE, set=FALSE, .gobi=NULL)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{scheme}{the \code{ColorScheme} object. }
  \item{name}{the name to identify/describe the scheme.}
  \item{overwrite}{a logical value indicating whether
    we should replace any existing entry with this name
    with the new scheme (\code{TRUE}), or simply append
    the new scheme to the end of the list.}
  \item{set}{a logical value that indicates whether
    to also make this the active color scheme.
    See \code{setActiveColorScheme}.}
  \item{.gobi}{the GGobi instance to which to append the new
    color scheme, or if this is \code{NULL},
    the color scheme is added to the session options and
   will be available to new GGobi instances created after this.}
}
\value{
  The index/position in the appropriate
  list of color schemes to which the
  new scheme was added.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
 \code{\link{setActiveColorScheme}}
 \code{\link{getColorSchemes}}  
}

\examples{
  
}
\keyword{visualization}
\keyword{interactive graphics}


\eof
\name{addXMLDataset}
\alias{addXMLDataset}
\title{Serialize dataset to GGobi's XML format.}
\description{
  This writes a dataset in the XML format
  used by GGobi
}
\usage{
addXMLDataset(data, name, dom, description = NULL)
}
\arguments{
  \item{data}{the dataset to be serialized.}
  \item{name}{the name to use for the \code{name} attribute for the dataset}
  \item{dom}{the output object to which to write the XML. This is
    usually an object of class \code{XMLOutputStream}.}
  \item{description}{an optional string or XML node giving a
    human-readable description of the dataset.}
}
\details{
  See \code{\link{writeDataXML}}. 
}
\value{

}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
 \code{\link{writeDataXML}}
}

\examples{

 data(mtcars)
 addXMLDataset()
 dd <- XMLOutputBuffer("ggobidata", close = FALSE)
 dd <- addXMLDataset(mtcars, "mtcars", dd, "The mtcars data taken from R")
 cat(dd$value())
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{close.ggobi}
\alias{close.ggobi}
\title{Terminates and discards a ggobi instance}
\description{
  This allows the caller to close a ggobi instance and discard the
resources it uses. The function closes the display windows and
variable panel window associated with this ggobi instance.
It also resets the default ggobi instance to be the last
one created.

\code{close} is a generic function in R that 
applies to objects of class \code{ggobi}, \code{ggobiDisplay} and
\code{ggobiDisplayDescription}.
}
\usage{
close.ggobi(con=getDefaultGGobi(),...)
}
\arguments{
  \item{con}{the object of class \code{ggobi} identifying the specific ggobi instance to be closed.
  This is named \code{con} to be consistent with the generic function.
  }
  \item{...}{ignored and here only for compatability with the associated generic function.}
}
\details{
 If the \code{.gobi} argument is specified, the 
default ggobi (i.e. that returned via \code{\link{getDefaultGGobi}}
is only modified if that object is the default ggobi instance.
}
\value{
 Returns a logical value indicating whether this operation
was successful or not.
}

\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{ggobi}}
\code{\link{getGGobi}}
\code{\link{getDefaultGGobi}}
\code{\link{close.ggobiDisplay}}
\code{\link{close.ggobiDisplayDescription}}
}

\examples{
 ggobi(args=c("-verbose", "-xml", system.file("data", "flea.xml", package="Rggobi")))
 close.ggobi()

  #  Open two ggobi instances.

 g1 <- ggobi(args=c("-verbose", "-xml", system.file("data", "flea.xml", package="Rggobi"), args="-noinit"))
 g2 <- ggobi(args=c("-verbose", "-xml", system.file("data", "buckyball.xml", package="Rggobi"), args="-noinit"))

  # Close g1
 close.ggobi(g1)
}
\keyword{visualization}
\keyword{interactive graphics}


\eof
\name{close.ggobiDisplay}
\alias{close.ggobiDisplay}
\alias{close.ggobiDisplayDescription}
\title{Close and discard a ggobi display/plot window.}
\description{
These functions allow one to discard a 
display window belonging to a ggobi instance.
}
\usage{
close.ggobiDisplay(con, ...)
close.ggobiDisplayDescription(con,...)
}
\arguments{
  \item{con}{the \code{ggobiDisplay} or \code{ggobiDisplayDescription}
   object that identifies the actual display window to be closed.}
  \item{...}{ignored but present to be consistent with the definition of the generic function.}
}
\details{
 Note that these are methods rather than functions that
can take integer values to identify the display 
and ggobi.
}
\value{
 A logical value indicating whether the close operation
 was successful (\code{TRUE}) or not (\code{FALSE}).
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}
\seealso{
 \code{\link{scatmat.ggobi}}
 \code{\link{scatterplot.ggobi}}
 \code{\link{parcoords.ggobi}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  d <- g$scatmat(1:3)
  close(d)

 
  g$parcoords(1:5)
     # close based on a description, specifically
     # its type and the particular variables
     # in the plot.
  for(i in g$getDisplays(T)) {
   if(names(i$Type) == "Parallel Coordinates") {
     if(!is.na(match("tars1", names(unlist(d$Plots)))))
      close(i)
   }
  }
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{createEdgeData.ggobi}
\alias{createEdgeData.ggobi}
\title{
 GGobi Dataset used for edges/connections
}
\description{
  This function creates an empty  GGobi dataset that can be used
  to connect points within another dataset.
  The idea is that we create this ``invisible'' dataset
  within the GGobi instance.
  We don't specify values for the edges in this call, but
  use \code{\link{setEdges.ggobi}} for this.
}
\usage{
createEdgeData.ggobi(numEdges, labels=rep("", numEdges), colors=NULL, .gobi=getDefaultGGobi())
}
\arguments{
  \item{numEdges}{the total number of edges to create}
  \item{labels}{the labels for the edges, which can be used in
    annotating the connections on a plot}
  \item{colors}{the colors to use for the edges when displaying them}
  \item{.gobi}{the GGobi instance}
}

\value{
  An object of class \code{ggobiEdgeDataset}
  which extends \code{ggobiDataset}.
}
\references{
\url{http://www.ggobi.org/RSggobi}
\url{http://www.ggobi.org}
}
\author{
Duncan Temple Lang
}
\note{
  The edge mechanism in GGobi is very powerful
  and supports a very general form of linking.
  As a result, simple uses may appear complex.
  The idea with this interface is to try to hide the complexity.
  However, you are advised to read the GGobi and RGGobi manuals
  to get a better understanding of edges and  linking.
}

\seealso{
  \code{\link{getEdges.ggobi}}
  \code{\link{setEdges.ggobi}}
  \code{\link{setDisplayEdges.ggobi}}
}

\examples{

}
\keyword{dynamic}

\eof
\name{describe.ggobi}
\alias{describe.ggobi}
\title{Provide a description of one or more ggobi instances}
\description{
 This returns a description of each of the ggobi instances identified
in the arguments. These should be specified as objects of class
\code{ggobi}. The result describes the current state of the ggobi
instance, including its datasets and displays.
}
\usage{
describe.ggobi(..., full=F)
}
\arguments{
  \item{\dots}{any number of \code{ggobi} objects. If no values are specfied,
   all GGobi instances are used.}
  \item{full}{(currently ignored) a logical value indicating whether the full
  or brief description should be returned for each ggobi instance.}
}
\value{
 This returns a list with as many elements as there are ggobi instances
specfied. Each element is a list of length $3$ with elements:
  \item{datasets}{a named list describing each dataset within this ggobi instance.
     Each description consists of 
     \item{name} a character vector containing the name of the dataset and the (primary) file
        from which it was read.
     \item{dims}  the number of records and variables in the dataset.
     \item{format} the data format of the file from which the data was read (e.g. XML, ASCII, 
         binary, MySQL, etc.)
     \item{variables} a character vector giving the names of the variables
     \item{auxillaryFiles} any additional files that were read when processing the 
        primary file (e.g. links in the XML file, .col and .rows files in ASCII format, etc.)
  }
  \item{displays}{ a list describing each of the displays within}
  \item{ggobi}{the ggobi instance from which this description was obtained}
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
 \code{\link{ggobi}}
 \code{\link{getGGobi}}
}

\examples{
 ggobi(args=c("-noinit", "-verbose", "-xml", system.file("data", "COI.xml", package="Rggobi")))
 describe.ggobi()
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getEdges.ggobi}
\alias{getEdges.ggobi}
\alias{setEdges.ggobi}
\title{Connections between points in a GGobi dataset}
\description{
  These functions allow the user to establish and query
  connections between points in a GGobi instance
  and use this information to show edge connections
  on displays.
}
\usage{
getEdges.ggobi(.data=1, .gobi=getDefaultGGobi())
setEdges.ggobi(x, y, append=T, .data=1, .gobi=getDefaultGGobi())
}
\arguments{
  \item{.data}{an identifier for the dataset within the GGobi instance,
    given as an index or an object of class the \code{ggobiDataset}}
  \item{.gobi}{an identifier for the GGobi instance which can be
    omitted if \code{.data} is a \code{ggobiDataset} object.
    Otherwise this should be an integer identifying the GGobi instance
    or a \code{ggobi} object.
  }
  \item{x}{a vector identifying the source of the edges
    by index or a 2 column matrix giving the source and destination}
  \item{y}{a vector giving the indeces of the destination nodes of the
    edges used together with \code{x}
  }
  \item{append}{a logical value indicating whether to add these to the
    dataset or to replace the existing connections with these.}
}
\details{
}
\value{
 A matrix giving the edge pairs before the call.
}
\references{
\url{http://www.ggobi.org}
}
\author{
Duncan Temple Lang
}
\note{
  The edge mechanism in GGobi is very powerful
  and supports a very general form of linking.
  As a result, simple uses may appear complex.
  The idea with this interface is to try to hide the complexity.
  However, you are advised to read the GGobi and RGGobi manuals
  to get a better understanding of edges and  linking.
}

\seealso{
  \code{\link{createEdgeData.ggobi}}
  \code{\link{setDisplayEdges.ggobi}}
}

\examples{


}
\keyword{dynamic}

\eof
\name{getColorSchemes}
\alias{getColorSchemes}
\title{Retrieve R descriptions of GGobi color schemes}
\description{
  This retrieves R objects representing a collection
  of GGobi color schemes directly from GGobi itself.
  It can access either a particular GGobi instance's
  color scheme list or the session-wide schemes.
  Color schemes can also be read from their XML
  representation, but this allows one to query
  the actual ones that are available to a GGobi
  session or instance.
}
\usage{
getColorSchemes(.gobi=NULL)
}
\arguments{
  \item{.gobi}{the GGobi instance from which to
    query the color schemes. If this is \code{NULL} (the default)
   the color schemes from the session options in GGobi are retrieved.}
}
\value{
  A list with an element for each
  color scheme in the GGobi list.
  Each element is an object of class
  \code{ColorScheme}.
}
\references{\url{http://www.ggobi.org}
 \url{http://www.ggobi.org/RSggobi}
}
\author{Duncan Temple Lang}
\seealso{
 \code{\link{addColorScheme}}  
 \code{\link{setActiveColorScheme}}
}

\examples{
}
\keyword{visualization}
\keyword{interactive graphics}


\eof
\name{getCurrentDisplayType.ggobi}
\alias{getCurrentDisplayType.ggobi}
\title{Get the active ggobi display type.}
\description{
 Returns a string describing the type of the 
currently active display in the specified 
ggobi instance.
}
\usage{
getCurrentDisplayType.ggobi(.gobi=getDefaultGGobi())
}
\arguments{
  \item{.gobi}{the ggobi instance identifier.}
}
\details{
 At any time, a ggobi instance has a single display or plot window
that is active and within that, a plot on which operations (e.g. brushing)
can be performed. This is the active plot.
}
\value{
 A string (character vector of length $1$) giving
the plot type.
The possible types can be retrieved via the function
\code{\link{getViewTypes.ggobi}}.
Currently these are 
 \code{"Parallel Coordinates"},
 \code{"Scatterplot"} and \code{"Scatterplot Matrix"}.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{getDisplays.ggobi}}
\code{\link{getDefaultGGobi}}
\code{\link{getViewTypes.ggobi}}
}

\examples{

}
\keyword{visualization}
\keyword{graphics}

\eof
\name{getDataModes.ggobi}
\alias{getDataModes.ggobi}
\title{The list of possible data formats and internal codes.}
\description{
 This returns the list of data formats that 
ggobi understands and their internal representations
which allows S to map string versions to a value
understood by the internal engine.
This is typically called by other functions
such as \code{\link{setData.ggobi}}
to interpret the data format.
}
\usage{
getDataModes.ggobi()
}
\details{

}
\value{
 A named vector giving the internal code identifying
the data format corresponding to that name.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}
\seealso{
\code{\link{setData.ggobi}}
\code{\link{setDataFile.ggobi}}
\code{\link{setDataFrame.ggobi}}
\code{\link{describe.ggobi}}
}

\examples{
  describe.ggobi()
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getDatasetReference}
\alias{getDatasetReference}
\alias{getDatasetReference.ggobi}
\alias{getDatasetReference.ggobiDisplay}
\alias{getDatasetReference.ggobiDisplayDescription}
\alias{getDisplayDataset.ggobi}
\title{Get an object representing an internal ggobi dataset}
\description{
It is convenient to be able to refer to and operate
on a ggobi dataset as if it were a regular S dataset.
 This generic function allows one to get an object that represents a
particular dataset and for which many of the standard methods used to
manipulate data frames, etc. are defined.  The object is of class
\code{ggobiDataset}.  One can derive such an object by index or name,
or from a \code{ggobiDisplay} or its fuller form
\code{ggobiDisplayDescription}.
}
\usage{
getDatasetReference(which, ...)
getDatasetReference.ggobi(which, .gobi=getDefaultGGobi())
getDatasetReference.ggobiDisplay(which)
getDatasetReference.ggobiDisplayDescription(which)
getDisplayDataset.ggobi(dpy, .gobi)
}
\arguments{
  \item{which}{an identifier for the particular dataset to be 
   foused to match agains the names of the datasets, or 
  altend within the ggobi instance. This can be a string which 
  is used to match agains the names of the datasets, or 
  alternatively an integer which is used to index into the list
  of the datasets in the ggobi instance.}
  \item{dpy}{an object of class \code{ggobiDisplay} or an integer
    identifying the particular display in the ggobi instance's display list.}
  \item{\dots}{other arguments that allow one to resolve the dataset,
   usually the \code{.gobi} argument.}
  \item{.gobi}{the ggobi instance in which to resolve the
   datgetDatasetReference.ggobiDisplay(which)aset. This should be an object of class \code{ggobi} or an integer identifying
   the instance in the list of all current ggobi instances.}
}

\value{
  The result is an object of class \code{ggobiDataset}
 and its contents are meaningless at the S language level.
 They are used only in internal C routines to identify 
 the dataset.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
 \code{\link{[.ggobi}}
 \code{\link{getDisplays.ggobi}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  g$setData(system.file("data", "sat.xml", package="Rggobi"))

  g[1]
  g["flea"]

  g["SAT scores"]

   # Get reference by index
  g$getDatasetReference(1)
   # by name
  g$getDatasetReference("flea")

   # get it from a ggobiDisplayDescription object
  d <- g$getDisplays(T)[[1]]
  getDatasetReference(d)

   # get it from a ggobiDisplay object
  d <- g$getDisplays()[[1]]
  getDatasetReference(d)
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getDefaultGGobi}
\alias{getDefaultGGobi}
\alias{setDefaultGGobi}

\title{Identifies the active/default ggobi instance}
\description{
 There can be multiple concurrent ggobi instances within an R session.
 One of them acts as the default to which commands are
 sent if the instance is not explicitly identified within
 the call (via the .gobi argument).
 \code{getDefaultGGobi} functions identifies the index of the instance which is the default.
 \code{setDefaultGGobi} tells the system which instance to treat as the default.
}
\usage{
 getDefaultGGobi()
 setDefaultGGobi(which)
}
\arguments{
 \item{which}{The index  of the ggobi instance which is
  to become the default. This should be an integer
  between 1 and the value of \code{\link{getNumGGobis}}}
}

\value{
 An integer vector of length 1.
}

\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{\code{\link{setDefaultGGobi}},
\code{\link{ggobi}}
}


\examples{
  # Create two ggobi instances
  # and find out which is default
  ggobi()
  ggobi()
  getDefaultGGobi()
  setDefaultGGobi(1)
  getDefaultGGobi()
}
\keyword{Visualization}

\eof
\name{getDescription.ggobi}
\alias{getDescription.ggobi}
\title{A brief description of a ggobi instance}
\description{
 This returns a brief version of the ggobi instance description,
giving the name of the file and mode of the data source
and the dimensions of the first dataset.
This is brief in contrast to the more complete
description provided by \code{\link{describe.ggobi}}.
}
\usage{
getDescription.ggobi(.gobi=getDefaultGGobi())
}
\arguments{
  \item{.gobi}{the identifier for the ggobi instance being queried.}
}
\value{
 A list with three elements:
  \item{Filename}{ the name of the primary input file from which the data was read.
   If the data was given directly from R, this is the description value supplied
   at theat time.}
  \item{Data mode}{the format in which the data was presented to ggobi.}
  \item{Data dimensions}{the number of records and variables in the dataset.}
  ... 
}

\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{ 
 \code{\link{describe.ggobi}}
 \code{\link{getGGobi}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  g$getDescription()
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getDisplayCount.ggobi}
\alias{getDisplayCount.ggobi}
\title{The number of displays within a ggobi instance.}
\description{
 This function yields the number of displays,
or plot windows, within a particular ggobi instance.
}
\usage{
getDisplayCount.ggobi(.gobi=getDefaultGGobi())
}
\arguments{
  \item{.gobi}{the identifier for the ggobi instance whose
    displays are to be queried.}
}
\value{
A single integer value giving the number of display
windows that are currently open.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}
\seealso{
\code{\link{getDisplays.ggobi}}
}
\examples{
 g <- ggobi(system.file("data", "sat.xml", package="Rggobi"), args="-noinit")
 g$scatmat(1:3)
 g$getDisplayCount()

 g$parcoords(c("tars1", "tars2"))
 g$getDisplayCount()
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getDisplays.ggobi}
\alias{getDisplays.ggobi}
\title{Query the displays/windows of a ggobi instance.}
\description{
 This returns a list of display or plot windows references or
 full descriptions of each display
 owned by a particular ggobi instance.
}
\usage{
getDisplays.ggobi(describe = F, .gobi=getDefaultGGobi())
}
\arguments{
  \item{describe}{a logical value indicating whether
  the full description should be returned (\code{TRUE}),
   or simply a reference to the display in the form of a
  code{ggobiDisplay}.}
  \item{.gobi}{the ggobi instance whose displays are to be described
   or referenced. This should be an object of class \code{ggobi} or an integer.}
}
\value{
A list with an element for each display 
in the ggobi instance.
If \code{describe} is specified as \code{TRUE},
each element
has $5$ components:
  \item{Name}{The title on the display's window.}
  \item{Type}{The type of display (e.g. scatterplot, parallel coordinat plot, \dots)
       given as a named integer vector whose value is the internal type
       code and whose name is a more descriptive identifier for the plot type.
     }
  \item{Plots}{A list describing each of the sub-plots within the display/window.
    Each element is a list containing 3 elements:
     \item{variables}{a named integer vector identifying the variables
       in the plot by both name and also index. (The indeces are problematic
        if one removes variables in the dataset).}
     \item{dataset}{an object of class \code{ggobiDataset} identifying the dataset in which the 
        variables are located.}
     \item{ggobi}{an object of class \code{ggobiInstance} specifying to which 
         ggobi the data and plot ``belong''.}
  }
  \item{dataset}{an object of class \code{ggobiDataset} which is a reference
     to the dataset that is associated with this display, i.e. which contains
     the variables in the different plots in this display.}
  \item{display}{an object of class \code{ggobiDisplay} which can be used to
    operate on the display and allows the need to refer to it by index.}

 If \code{describe} is \code{FALSE}, each element is
 an object of class \code{ggobiDisplay} and this is an opaque
 reference to the internal C-level dataset.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{ 
\code{\link{getPlotType.ggobi}}
\code{\link{getPlotCount.ggobi}}
}

\examples{
 g <- ggobi(system.file("data", "flea.xml", package="Rggobi"))
 g$scatmat(1:3)
   # Now see what we have.
 g$getDisplays(T)

   # Get references to the displays and close the 
   # second one.
 close(g$getDisplays()[[2]])
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getFileNames.ggobi}
\alias{getFileNames.ggobi}
\title{Identify the files associated with a ggobi instance's data sets.}
\description{
It is often convenient to be able to query the source of
a data set currently in ggobi. When the data is read
from a file, the name of the file or URL is sufficient.
This function returns the name of the primary file from which 
the data was read. 
It can also be asked to return a list of the secondary 
or auxillary files that were read due to a reference
in the primary file.
}
\usage{
getFileNames.ggobi(auxillary=F, .gobi=getDefaultGGobi())
}
\arguments{
  \item{auxillary}{a logical value indicating whether to retur
    the secondary or auxillary files that were read based on a reference
    in the primary or other files.
   }
  \item{.gobi}{the ggobi instance whose data sources are to be queried.}
}

\value{
 A list with an element for each dataset in the ggobi instance.
 If \code{auxillary} is \code{FALSE}, each element is a
 single string giving the name of the primary file containing the data.
 If \code{auxillary} is \code{TRUE}, the list's element is a character
 vector containing all the files read when processing the primary file.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{getGGobi}}
\code{\link{setData.ggobi}}
}

\examples{
 g <- ggobi(system.file("data", "sat.xml", package="Rggobi"), args="-noinit")
 g$setData(system.file("data", "sat.xml", package="Rggobi"), add=T)

 g$getFileNames()
}
\keyword{dynamic}


\eof
\name{getGGobi}
\alias{getGGobi}
\title{Returns a ggobi reference}
\description{
 This allows one to get a list of all the ggobi
 instances currently in existence in the R session.
 Also, one can fetch particular instances. 
 This function returns objects of class \code{ggobi}
 which can the be used as the \code{.gobi} argument
 in the different function calls, and also
 for invoking these functions in a more convenient
 form, i.e.
  \code{names(g)}
 Additionally, these are returned as objects of class
reference
 It is most convenient to call the ggobi functions 
}
\usage{
getGGobi(...)
}
\arguments{
  \item{\dots}{identifiers, typically integers, identifying
  which ggobi instances are to be returned. If no values are 
  specified, a list of all the ggobi instances is returned.
  }
}
\value{
 A list of the ggobi instances identified by the
 \code{\dots} arguments.
 Each element is an object of class \code{ggobi}.
 If there is a single argument, the list is collapsed
 and the single object of class \code{ggobi} is returned.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{ 
 \code{\link{getDefaultGGobi}}
 \code{names.ggobi}
 \code{$.ggobi}
}

\examples{
  ggobi(system.file("data", "sat.xml", package="Rggobi"), args="-noinit")
  g <- getGGobi()
  if(!is.null(g)) {
    if(!inherits(g, "ggobi"))
       g <- g[[1]]
    names(g)
    g$getColors()
    getColors.ggobi(.gobi = g)
  }
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getGlyphTypes.ggobi}
\alias{getGlyphTypes.ggobi}
\alias{getGlyphSizes.ggobi}
\title{Get the names and sizes of ggobi's available glyphs for displaying points in a plot.}
\description{
 These functions allow one to query the names (and internal codes)
 and possible sizes of the glyphs that ggobi understands and can
 use to display points on a plot.
}
\usage{
getGlyphTypes.ggobi()
getGlyphSizes.ggobi()
}
\value{
\code{getGlyphTypes.ggobi} A named integer vector containing the 
internal ggobi glyph identifier, indexed by its external name representation.

\code{getGlyphTypes.ggobi} An integer vector giving
the possible sizes that one can specify for a glyph.
}
}
\references{\url{http://www.ggobi.org/RSggobi.html}}
\author{Duncan Temple Lang}

\seealso{
 \code{\link{getGlyphs.ggobi}}
}

\examples{
  getGlyphTypes.ggobi()

  g <- ggobi(system.file("data","flea.xml", package="Rggobi"), args="-noinit")
  g$setGlyphs(max(getGlyphSizes.ggobi()))
}
\keyword{visualization}
\keyword{interactive graphics}


\eof
\name{getGlyphs.ggobi}
\alias{getGlyphs.ggobi}
\alias{setGlyphs.ggobi}
\title{Get or set the glyphs for records in a ggobi dataset}
\description{
 This allows one to set or retrieve the specifications
for the glyph rendering of points in plots
for records within a ggobi dataset.
The glyph specification is made up of  a particular
plotting character and size.
}
\usage{
getGlyphs.ggobi(which, .data =1, .gobi=getDefaultGGobi())
setGlyphs.ggobi(types, sizes, which, .data = 1, .gobi=getDefaultGGobi())
}
\arguments{
  \item{which}{a vector identifying to which records or cases the operation
    applies}
  \item{types}{a vector giving the name or identifier for the glyphs.}
  \item{sizes}{an integer vector wit the same length as types giving 
    the size of the glyph for each record identified
    in which.}
  \item{.data}{the dataset identifier, typically a number or
    the name of the dataset.}
  \item{.gobi}{ the ggobi instance in which the dataset is to be found.}
}
\value{

}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{ 
 \code{\link{getGlyphTypes.ggobi}}
 \code{\link{getGlyphSizes.ggobi}}
 \code{\link{mapGlyphType}}
}

\examples{

}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getModeNames.ggobi}
\alias{getModeNames.ggobi}
\title{Returns the names of the different modes understood by ggobi.}
\description{
 Each ggobi instance is in one mode at any given time. For example,
brushing, identifying points, editing lines, etc. are possible modes.
This function returns the names of the different modes
in which a ggobi instance can be. One uses these names
to set and determine the current mode.
Since these rarely change, this function is primarily
used by those learning about the ggobi system 
interactively.
}
\usage{
getModeNames.ggobi()
}
\value{
 A character vector giving the names of the
different modes.
}
\references{\url{http://www.ggobi.org/RSggobi.html}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{setMode.ggobi}}
\code{\link{getMode.ggobi}}
}

\examples{
  getModeNames.ggobi()
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getNumDatasets.ggobi}
\alias{getNumDatasets.ggobi}
\title{Get the number of datasets in a ggobi instance.}
\description{
  This returns the number of datasets within a ggobi instance.
}
\usage{
getNumDatasets.ggobi(.gobi=getDefaultGGobi())
}
\arguments{
  \item{.gobi}{the ggobi instance whose number of datasets is to be queried.
    This can be an object of class \code{ggobi} or an integer identifying
   the ggobi instance by position in the current list of ggobi instances.}
}
\value{
 A single integer giving the numbe of datasets in the specified ggobi instance.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
 \code{\link{names.ggobi}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  g$setData(system.file("data", "sat.xml", package="Rggobi"))

  g$getNumDatasets()
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getNumGGobis}
\alias{getNumGGobis}
\title{ The number of ggobi instances within this session}
\description{
 One or more ggobi instances can be created within an R
session so that one can simultaneously look at different datasets 
or have different views of the same dataset.
This function returns the number of ggobis in
existence. This can be used in conjunction
with \code{\link{setDefaultGGobi}} to
soecify which ggobi instance should receive 
commands by default.
}
\usage{
 getNumGGobis()
}
%- maybe also `usage' for other objects documented here.
\details{
 The different ggobi instances are maintained as C 
level structures. This function accesses a variable
that stores how many are in existence when the function
is invoked.
}
\value{
 An integer vector of length 1
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{\code{\link{setDefaultGGobi}},
\code{\link{getDefaultGGobi}},
\code{\link{ggobi}}
}

\examples{
  # Get the total number of ggobi instances
 getNumGGobis()

 # Loop over all the ggobi instances and print
 # their basic characteristics
 for(i in 1:getNumGGobis())
  print(getDescription.ggobi(.gobi = i))


 # Make the last ggobi instance created
 # the default one.
 setDefaultGGobi(getNumGGobis())
}
\keyword{Visualization}

\eof
\name{getSimpleTreeSlots}
\alias{getSimpleTreeSlots}
\alias{getSimpleTreeSlots.CategoricalVariableInfo}
\alias{getSimpleTreeSlots.RealVariableInfo}
\alias{getSimpleTreeSlots.VariableInfo}
\title{Names of slots to display in VariableInfo object}
\description{
  This returns the names of the slots/elements to display
  in a tree for this particular type of object.
  This excludes certain slots that are either
  not to be shown or to be rendered in a more complex
  manner in \code{\link{xmlDataTreeViewer.VariableInfo}}.
}
\usage{
getSimpleTreeSlots(obj)
getSimpleTreeSlots.CategoricalVariableInfo(obj)
getSimpleTreeSlots.RealVariableInfo(obj)
getSimpleTreeSlots.VariableInfo(obj)
}
\arguments{
  \item{obj}{the \code{VariableInfo} object}
}
\value{
  A character vector giving the names of the
  elements in \code{obj} to display as simple
  tree items.
}

\seealso{ }

\examples{

}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getSmootherFunction.ggobi}
\alias{getSmootherFunction.ggobi}
\alias{setSmootherFunction.ggobi}
\title{Get or set the R function used by ggobi to perform smoothing}
\description{
DEPRECATED and NON-FUNCTIONAL.  These functions allow the user to specify and query a function
that ggobi uses when computing the smoothed values for predicting
one variable from another.
}
\usage{
getSmootherFunction.ggobi(.gobi=getDefaultGGobi())
}
\arguments{
  \item{fun}{the function that it is to be set as the 
active smoothing function for ggobi. This should take $3$ arguments:
\code{x}, \code{y} and the span or bandwidth of the smoothing.
The first two are numeric vectors of length $n$, the number of observations
and the last is a single numeric value.}
  \item{.gobi}{the GGobi identifier, either an integer giving the
 GGobi by index or an object of class \code{ggobi}}
}
\details{
 This sets a single internal C symbol to point to this function.
If it is non-NULL, ggobi will use the value as the address of an
R function and call it.
}
\value{
}

\references{\url{http://www.ggobi.org},\url{http://www.ggobi.org/Rggobi}}
\author{Duncan Temple Lang}

\seealso{ 
\code{\link{setSmootherFunction.ggobi}}
}

\examples{
\dontrun{
 library(modreg)
 setSmootherFunction(function(x, y, w) {
                       predict(loess(y ~ x, data.frame(x=x, y = y), span = w))
                      })
 


 getSmootherFunction()
}
}
\keyword{visualization} 
\keyword{interactive graphics}  

\eof
\name{getVariable.ggobi}
\alias{getVariable.ggobi}
\title{Get the values of a GGobi variable}
\description{
  This retrieves the values of a variable within a GGobi dataset,
  handling categorical variables as S factors.
}
\usage{
getVariable.ggobi(which, .data=1, .gobi=getDefaultGGobi(), asDataFrame=F)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{which}{the identifiers for the variables to be retrieved,
   given by index or variable name}
 \item{.data}{an identifier for the dataset, either an index,
   name or \code{ggobiDataset} object.}
 \item{.gobi}{the GGobi instance, given by index or an object
   of class \code{ggobi}. The currently active GGobi instance
  is used by default.}
  \item{asDataFrame}{a logical value indicating whether
    the result should be given as a data frame or
    left as a list.}
}
\value{
  A dataframe or a list (depending on whether
  \code{asDataFrame} is \code{TRUE} or \code{FALSE})
  whose elements are the variables copied from the
  GGobi dataset.
}
\references{
\url{http://www.ggobi.org/RSggobi}
\url{http://www.ggobi.org}
}
\author{Duncan Temple Lang}

\seealso{
  \code{\link{setVariableValues.ggobi}}
  \code{\link{[.ggobiDataset}}
  \code{\link{[.ggobiDataset}}
}

\examples{
 ggobi(system.file("data", "flea", package="Rggobi"))
 getVariable.ggobi("tars1")
 getVariable.ggobi(1)
}
\keyword{dynamic}

\eof
\name{getVariableIndex.ggobi}
\alias{getVariableIndex.ggobi}
\title{Convert variable names into indices.}
\description{
 It is best to refer to variables in ggobi datasets by name,
 but these are converted to indices when passed to internal C code.
 This function performs this mapping by matching the
 specified variable names against those of the dataset in which
 they are to be resolved. 

 In most cases, the user does not have to call this function
 directly. The other functions in the package that operate on
 ggobi variable references call this function implicitly.
}
\usage{
getVariableIndex.ggobi(..., .data = 1, .gobi=getDefaultGGobi()) }
\arguments{
  \item{\dots}{the names (or indices) of variables to resolve
   and compute the internal indices. Non-character values are left unaltered
   and returned as is.}
  \item{.data}{the identifier for the dataset against which to resolve the
    variable names. This should be an object of class \code{ggobiDataset},
    a name (as returned from names.ggobi), or an integer giving the dataset by order.}
  \item{.gobi}{the identified for the ggobi instance in which to find the dataset.}
}

\value{
  An integer vector giving the indices of the variables
referenced in the \code{\dots} arguments.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}


\examples{
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getVariableNames.ggobi}
\alias{getVariableNames.ggobi}
\alias{setVariableNames.ggobi}
\title{Variable names of a ggobi dataset}
\description{
 This sets or retrieves the names of the 
variables within a ggobi dataset.
}
\usage{
getVariableNames.ggobi(tform=F, .data = 1, .gobi=getDefaultGGobi())
setVariableNames.ggobi(..., .data = 1, .gobi=getDefaultGGobi())
}
\arguments{
  \item{tform}{a logical value indicating whether the
names of the transformed variables (\code{TRUE}) or the regular names (\code{FALSE})
are to be returned.
}
  \item{.data}{the identifier for the dataset the name of whose variables
 are to be returned. This can be an object of class \code{ggobiDataset},
 the name of the dataset (returned by \code{names.ggobi})
or an integer index. }
  \item{.gobi}{The identifier for the ggobi instance in which to find the
dataset. This should be an object of class \code{ggobi} or alternatively
an integer identifying the ggobi instance by order. See \code{getDefaultGGobi},
\code{getGGobi} and \code{getNumGGobis}.}
  \item{...}{a collection of \code{name=value} pairs giving the current name of
  a variable and its new name in the form \code{current=new}}
}
\details{
 This resolves the ggobi instance, then the dataset and
returns the variable names.
}
\value{
 A character vector containing the names of the variables
in the specifid dataset.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{dimnames.ggobiDataset}
\code{colnames.ggobiDataset}
\code{names.ggobi}
}

\examples{
  g <- ggobi(system.file("data","flea.xml", package="Rggobi"), args="-noinit")

   # Use the default ggobi and dataset
  getVariableNames.ggobi()

  getVariableNames.ggobi(.data = g[1])

  dimnames(g[1])[[2]]  
  colnames(g[1])  
  names(g[1])


  g$setData(system.file("data", "sat.xml", package="Rggobi"), add=T)
  getVariableNames.ggobi(.data="SAT scores")
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getVersion.ggobi}
\alias{getVersion.ggobi}
\title{ggobi version information}
\description{
Return an object that describes the version of the ggobi 
library being used. This allows code to execute 
conditionally on certain version numbers, etc.
}
\usage{
getVersion.ggobi()
}
\value{
 An list with three elements:
  \item{date}{the release date of the ggobi library}
  \item{version}{a vector of 3 integers containing the major, minor and patch-level numbers.}
  \item{version string}{ a string version of the major, minor and patch-level numbers,
     using the . and - separators.}
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}


\examples{
 getVersion.ggobi()
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{getViewTypes.ggobi}
\alias{getViewTypes.ggobi}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Obtains the names and internal symbolic constants of the ggobi plot types.}
\description{
This gives the identifiers by which one can refer to 
the internal plot types that ggobi understands.
This is used when creating new plots and also when
mapping the types of existing plots to human readable
form.
This is not very useful by itself, but does tell
the user what types of plots ggobi is capable of
creating.
}
\usage{
getViewTypes.ggobi()
}
\arguments{
 No arguments.
}
\value{
 A named integer vector. The values are the internal
codes for the particular plot type identified by 
the name for that elememtn.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{

}

\examples{
  getViewTypes.ggobi()
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{ggobi}
\alias{ggobi}
\title{Creates a new ggobi instance}
\description{
Create a new instance of a GGobi control panel
with or without new data.
This new GGobi will operate indepdently of the others
in the R session and will not share linked plots.
}
\usage{
  ggobi(data = NULL, args=character(0), mode=character(0))
}
\arguments{
 \item{data}{the name of a file containing the data to be loaded
or a data frame or matrix containing the values}
 \item{args}{a character vector of arguments that are given to the
ggobi engine as if they were specified as command line arguments
to the stand-alone ggobi. This includes flags such as \texttt{-xml},
\texttt{-a}, etc. to specify the mode of the data being read from a file.}
\item{mode}{the name of the data format GGobi should expect to read
 the data from, if reading from a file.}
}
\details{
 This creates a new ggobi object which manages one or more
related datasets and a linked collection of views of the values in
those datasets.
}
\value{
 An object that can be used in subsequent calls
to identify this particular ggobi instance.
This is a list with two elements:
 \item{id}{an integer identifying which ggobi instance
  this was within the R session.}
 \item{ref}{the C-level address of the internal \code{ggobid} structure. Do no use!}
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{getDefaultGGobi}},
\code{\link{getNumGGobis}}
}

\examples{
 ggobi(system.file("data", "flea.dat", package="Rggobi"), c("-noinit", "-a"))
 ggobi(system.file("data", "flea.xml", package="Rggobi"), c("-noinit", "-xml"))

 ggobi(system.file("data", "flea.xml", package="Rggobi"), args= "-noinit")

 data(mtcars)
 ggobi(mtcars)
}
\keyword{dynamic}


\eof
\name{ggobi accessors}
\alias{$.ggobi}
\title{Convenience accessor for calling ggobi methods}
\description{
 Most of the functions in this ggobi package act on a ggobi
instance. The \code{$} operator allows one to treat these functions as
method calls on the instance, in the form of \code{g$method}.  This
allows one to explicitly indicate which ggobi instance is being used
and also to avoid typing the \code{.ggobi} suffix for the different
functions.
}
\usage{
"$.ggobi"(x, name)
}
\arguments{
  \item{x}{the ggobi instance in the form of an object of class  \code{ggobi}.}
  \item{name}{the name of the function to be invoked, without the 
  \code{.ggobi} suffix.}
}
\value{
 This creates a closure which ``remembers'' the 
\code{ggobi} instance \code{g} and returns a function
which will call the function named  \textit{name}\code{.ggobi}
with that \code{ggobi} object as the named argument
\code{.gobi}. 
This is then called directly and its return value
rarely stored for future computations.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}
\seealso{
 \code{\link{$.ggobi}}
All functions that take a \code{.gobi} argument
and are named \code{*.ggobi}.
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"))
  g$getDisplays()
  g$getDisplayCount()
  g$getDatasetReference(1) # g[1]
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{ggobiDataset accesors}
\alias{$.ggobiDataset}
\title{Shorthand for calling ggobi functions with a given dataset.}
\description{
 Many functions in this package operate on a dataset within
 a ggobi instance. This function provides a convenient syntax for
invoking such functions by keying off a reference to a dataset (i.e. a
\code{ggobiDataset} object) which identifies both the dataset and
the ggobi instance. 
}
\usage{
"$.ggobiDataset"(d, name)
}
\arguments{
  \item{d}{ the object of class \code{ggobiDataset} which identifies
  both the ggobi instance and specific dataset within it.}
  \item{name}{the name of the function to be accessed with this
 dataset and ggobi instance.}
}
\value{
 A closure instance that is a function which 
 calls the function \textit{name}\code{.ggobi}
 with the \code{.data} argument given by this 
 data set object and \code{.ggobi} argument given
 by the \code{.ggobi} field of that \code{ggobiDataset} instance.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}
\seealso{
 \code{\link{$.ggobi}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  d <- g[1]
  d$getColors()
  g[1]$getGlyphs()
  
  g[1]$setColors(rep(2,20), 1:20) # or use a color name.
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{isValid.ggobi}
\alias{isValid.ggobi}
\title{Determines whether a reference to an internal ggobi object is valid}
\description{
 One can create multiple, independent ggobi instances within a single
R session and one can also remove them either programmatically or
via the GUI.  To be able to refer to these objects which are
actually C-level internal objects, one has a reference or handle
from an S object. Since the C level object can be destroyed
while the S object still refers to them, this function
allows one to check whether the internal object
to which S \code{ggobi} object refers is still in existence.
}
\usage{
isValid.ggobi(.gobi)
}
\arguments{
  \item{.gobi}{an object of class \code{ggobi} which refers to an
    internal ggobi instance.}
}
\value{
 A logical value with \code{TRUE} indicating that
the reference identifies a real object that currently
exists within the ggobi engine, or \code{FALSE}
that the C level object to which the S object refers no longer exists.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}
\seealso{
\code{\link{ggobi}}
\code{\link{close.ggobi}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")

   # still valid
  isValid.ggobi(g)  

  close(g)

   # no longer valid.
  isValid.ggobi(g)  
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{mapGlyphType}
\alias{mapGlyphType}
\title{Maps glyph names to their internal integer value}
\description{
 This is an ``internal'' or ``infrequently called by users'' function
that takes one or more glyph names (specified as strings) and matches them
agains tthe names of the possible glyphs understood by ggobi and
returns the identifiers (integers) corresponding to ggobi's internal
representation of those glyphs.
}
\usage{
mapGlyphType(types)
}
\arguments{
  \item{types}{a character vector identifying one or more glyphs by name.
  See \code{\link{getGlyphTypes.ggobi}}
}}
\details{
 This queries the ggobi code to ask for the glyph representations
(integers) and names and then matches the user specified values
against these names.
}
\value{
  An integer vector containing the 
internal ggobi glyph identifiers for the glyph types identified by the
user-specified names.
}
\keyword{visualization}
\keyword{interactive graphics}

\seealso{
\code{\link{getGlyphSizes.ggobi}}
}

\examples{
  mapGlyphType(c("plus", "x"))
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{names.ggobi}
\alias{names.ggobi}
\title{Names of the datasets within a ggobi instance.}
\description{
 This returns the names of the datasets within 
the specified ggobi instance.
}
\usage{
names.ggobi(x)
}
\arguments{
  \item{x}{the ggobi instance whose datasets are to be queried.}
}
\details{
 The name of a dataset is dependent on the format of the file
from which it was read. In XML,
the name of the dataset can be supplied with each dataset.
In ASCII input,  the name of the dataset is the name of 
the file from which the data was read.
}
\value{
 A character vector containing the names of the datasets.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}


\seealso{
\code{\link{[.ggobi}}
\code{\link{getDatasetReference.ggobi}}
}

\examples{
   g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
   names(g)
   g[names(g)[1]]
   g[1]
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{parcoords.ggobi}
\alias{parcoords.ggobi}
\title{Creates a ggobi parallel coordinates display.}
\description{
 This creates a new display window in the specified
ggobi instance and populates it with a Parallel Coordinates
plot containing 2 or more variables.
}
\usage{
parcoords.ggobi(..., .data = 1, .gobi=getDefaultGGobi())
}
\arguments{
  \item{\dots}{Identifiers for the variables that are to be displayed
in the parallel coordinates plot.
These can be either names of variables or 
As with all ggobi plots, the variables must be in the same 
dataset.}
  \item{.data}{the dataset in the ggobi instance in which to resolve the
variable identifiers. This can be an integer giving the position
of the dataset in the ggobi list of datasets, the name of the dataset
(as returned by \code{names.ggobi}), or preferably, 
an object of class \code{ggobiDataset}.}
  \item{.gobi}{
the identifier for the ggobi instance in which to find the
dataset and also add the newly created display.
This can be an integer identifying the  ggobi instance
by order, or an object of class \code{ggobi} returned
from either \code{\link{ggobi}} or \code{\link{getGGobi}}.
}
}
\value{
An object of class \code{ggobiDisplay}.
This is an opaque type whose contents are
to be interpreted by C code and other S functions
only.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{scatmat.ggobi}}
\code{\link{scatterplot.ggobi}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  g$parcoords(colnames(g[1]), .data=g[1])

   #
  g$parcoords("tars1", "tars2")
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{plotLayout}
\alias{plotLayout}
\alias{gtkCells}
\title{Creates and arranges individual plots in a flexible grid layout.}
\description{
 This creates ggobi plots - be they basic or composites of basic plots -
and lays them out in the cells of a grid specified by the caller.
All the plots are contained in a single window.
This gives the R user complete control of the contents of a given
display/window in a ggobi instance, providing greater flexibility
than is possible with a graphical interface.
}
\usage{
plotLayout(..., mfrow=NULL, cells=NULL, .data = 1, .gobi=getDefaultGGobi(), display=-1)
gtkCells(r, c)
}
\arguments{
  \item{\dots}{a collection plot descriptions }
  \item{mfrow}{an integer vector of length 2 specifying the number of rows and columns 
  of the grid. Note that not alll cells must be filled. }
  \item{cells}{a 4 by k matrix in which each column gives the indices of the adjacent 
cells of the plot}
  \item{.gobi}{an integer identifying the instance of the ggobi to which the
data and display  are connected.}
  \item{r}{the number of rows to use for the cell table}
  \item{c}{the number of columns to use for the cell table}
  \item{display}{an integer identifying the display to which the plots should be added.
If this is omitted, a new display (i.e. window) is created.}
  \item{.data}{the identifier (index,  name or dataset reference) of the dataset which is to be used
to resolve variable names in the specified \code{.ggobi} (if the descriptions
do not contain this information)
}
}

\value{
 The index (as an integer) of the display which was created or
 to which the plots we added.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{scatmatrixDescription}},
\code{\link{parallelCoordDescription}},
\code{\link{ashDescription}}
\code{\link{scatterplotDescription}}
}

\examples{
  plot4 <- ashDescription("tars2")
  plot5 <- scatmatrixDescription("tars1", "tars2", "head") 
  plot6 <- parallelCoordDescription("tars1", "tars2", "head")

  g <- ggobi(system.file("data","flea.xml", package="Rggobi"))
   #
  dpy <- plotLayout(plot4, plot5, mfrow=c(1,2), .gobi = g)

   #
  cl <- gtkCells(2,2)[-3,]
  cl[3,1] <- 1
  plotLayout(plot4, plot5,plot6, mfrow=c(2,2), cells=t(cl))
}
\keyword{visualization}


\eof
\name{plotList}
\alias{plotList}
\title{Collection of Plot description/templates}
\description{
 This is used to gather individual plot description
 or template objects into a collection
 to make it easier to dispatch methods
 and also to optionally associate a layout for this collection.
 This essentially acts as another form of template
 or display description.
}
\usage{
plotList(..., mfrow=NULL, cells=NULL)
}
\arguments{
  \item{\dots}{one or more plot description objects.}
  \item{mfrow}{the grid dimensions for arranging the plot
   in \code{\link{plotLayout}}}
  \item{cells}{the cells the individual plots are to occupy
   in the grid layout. These are typically computed by a call
   to \code{\link{gtkCells}}.}
}

\value{
 A list containing the arguments
 \item{plots}{ a list }
 \item{mfrow}{}
 \item{cells}{}
 given as an object of  class \code{ggobiPlotList}
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{ 
 \code{\link{ashDescription}}
 \code{\link{scatterplotDescription}}
 \code{\link{scatmatrixDescription}}
 \code{\link{parallelCoordDescription}}
 \code{\link{plotLayout}}
 \code{\link{resolvePlotDescription}}
}

\examples{
  plotList(ashDescription("tars1"), scatterplotDescription("tars1", "head"))
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{print.ggobi}
\alias{print.ggobi}
\alias{print.ggobiDataset}
\title{Convenient display of ggobi reference objects}
\description{
 These functions display the opaque references to 
 internal ggobi instances in convenient form
 that hides the internal contents of the object.
}
\usage{
print.ggobi(x, ...)
print.ggobiDataset(x, ...)
}
\arguments{
  \item{x}{the object to be printed on the console}
  \item{\dots}{other arguments influencing how the object should be presented.
    These are ignored.}
}
\value{
 A character vector containing the displayed/printed value.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\examples{
   g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
   print(g)
   print(g[1])
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{readXMLColorSchemes}
\alias{readXMLColorSchemes}
\title{Read color schemes from XML format.}
\description{
  This reads an XML document (either a file, string or via
  HTTP or FTP)
  and process the contents as color schemes.
  It creates a list of these colorschemes indexed by their
  names. Each element is a \code{ColorScheme} object
  with a more specific sub-class.
}
\usage{
readXMLColorSchemes(uri, handlers=xmlColorSchemeHandlers())
}
\arguments{
  \item{uri}{the name/identifier for the XML document.}
  \item{handlers}{the set of XML node handlers that process the
    document and create the R data structures representing the color schemes.}
}
\value{
  A list with as many elements as there are color schemes.
  Each element extends the class \code{ColorScheme}.
}
\references{\url{http://www.ggobi.org}
  \url{http://www.ggobi.org/RSggobi}
}
\author{Duncan Temple Lang}
\seealso{
 \code{\link{xmlColorSchemeHandlers}}
}

\examples{
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{resolveColors.ggobi}
\alias{resolveColors.ggobi}
\title{Map names to color values in a ggobi instance.}
\description{
  This currently does not work but will when color schemes
  are enabled in GGobi.

  Colors in ggobi are represented by entries in a color
  table or matrix as Red, Green and Blue values.
  To set a color, one can identify the entry in that table 
  either by number/index or by name.
  This function maps color names to the corresponding
  index so that these values can be passed to the low-leve
  C routines.  This function is typically called internally.
}
\usage{
resolveColors.ggobi(..., .gobi=getDefaultGGobi())
}
\arguments{
  \item{\dots}{names of colors to be resolved in the default
   color map of the ggobi instance.}
  \item{.gobi}{the ggobi instance whose default color map is to 
   be used to resolve the names.}
}
\value{
 An integer vector specifying the indices of the 
 entries in the color map corresponding to the specified
names.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{ 
 \code{\link{getColors.ggobi}}
 \code{\link{setColors.ggobi}}
 \code{\link{getColorMap.ggobi}}
 \code{\link{setColorMap.ggobi}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"))
\dontrun{
  g$resolveColors("red", "green")
}
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{resolvePlotDescription}
\alias{resolvePlotDescription}
\title{Maps the variable references in a virtual plot description.}
\description{
  Plot descriptions are templates for creating plots.
 The variables in the plot description are virtual in the sense
that they have not been resolved to a particular dataset and variable.
 This function performs that mapping, returning a fully self-describing
 plot description from which a real plot can be instantiated directly. 

This function is not typically called by the user, but used
internally by the \code{\link{plotLayout}} function.
}
\usage{
resolvePlotDescription(desc, .data = 1, .gobi=getDefaultGGobi(), isError = T)
}
\arguments{
  \item{desc}{ the plot description whose variable references are to be resolved.}
  \item{.data}{the dataset in the ggobi instance relative to which the variable
  references will be resolved. This should be specified as a \code{ggobiDataset},
   name or integer.}
  \item{.gobi}{the ggobi instance in which to find the dataset. If \code{.data}
  is supplied as a \code{ggobiDataset}, this is not used. Otherwise, it can be
  a \code{ggobi} object or an integer }
  \item{isError}{a logical value, if TRUE means an error is generated if 
    any of the variables are not found in the GGobi dataset. The purpose
    of this argument is to allow the caller to turn off errors in order to 
    process multiple plots and then report the missing variables for all of them.
    This is often preferrable to reporting the first error and have the user
    solve the problems iteratively.}
}
\value{
 An object of the same class as the input argument \code{desc},
but with the \code{.ggobi} and \code{.data} slots 
substituted with the values given in the call, and
the variable references converted to integers identifying
the variables within the dataset referenced by this object
(in the \code{.data} field).
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{plotLayout}}
\code{\link{scatterplotDescription}}
\code{\link{ashDescription}}
\code{\link{scatmatrixDescription}}
\code{\link{parallelCoordDescription}}
}

\examples{

}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{scatmat.ggobi}
\alias{scatmat.ggobi}
\title{Create a ggobi scatterplot matrix display}
\description{
Creates a new window under the management of the specified ggobi
instance containing a grid of all pairwise scatterplots of the
variables specified in the \code{x} and \code{y} arguments.  The
display is similar to that produced by the \code{\link{pairs}} 
function, but is interactive and dynamic, allowing linking
across the other plots within the ggobi instance.
Greater control of which pairs of variables are plotted
together can be obtained by specifying both \code{x} and
\code{y}.
}
\usage{
scatmat.ggobi(x, y, .data=1, .gobi=getDefaultGGobi())
}
\arguments{
  \item{x}{the names or indices of the variables to plot}
  \item{y}{if specified,  this should have the same length
as \code{x} and then the pair \code{(x[i], y[i])}
 are plotted.
}
  \item{.data}{}
  \item{.gobi}{the ggobi instance in which the plot is created
and the variable identifiers resolved.}
}

\value{
 An object of class \code{ggobiDisplay}.
This is an opaque type whose contents are
to be interpreted by C code and other S functions
only.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{scatterplot.ggobi}}
\code{\link{parcoords.ggobi}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  scatmat.ggobi(1:3)
  scatmat.ggobi(c("tars1", "tars2", "aede1"))
}
\keyword{visualization}


\eof
\name{scatterplot.ggobi}
\alias{scatterplot.ggobi}
\title{Creates a ggobi display containing a single scatterplot}
\description{
 This adds a new display window to the specified ggobi instance
which contains a scatterplot of the two variables
}
\usage{
scatterplot.ggobi(x, y, .data=1, .gobi=getDefaultGGobi())
}
\arguments{
  \item{x,y}{identifiers for the two variables to be displayed in the scatterplot.
These should be given by name (as returned by \code{dimnames.ggobiDataset}, etc.).
Alternatively, they can be given by index (starting at $1$).
As with all ggobi plots, the variables must be in the same dataset.
}
  \item{.data}{the identifier for the dataset within the ggobi
instance in which the \code{x} and \code{y} identifiers are to be resolved.
This can be an integer giving the index of the desired dataset (starting at $1$),
the name of the dataset (as returned by \code{\link{names.ggobiDataset}},
or, preferrably, an object of class \code{ggobiDataset}).
If the last of these is used, the \code{.ggobi} argument is not used.}
 \item{.gobi}{the identifier for the ggobi instance, either an integer
giving it by index or an object of class \code{ggobi}.}
}
\value{
 An object of class \code{ggobiDisplay}.
This is an opaque type whose contents are
to be interpreted by C code and other S functions
only.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{scatmat.ggobi}}
\code{\link{parcoords.ggobi}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  g$scatterplot("tars1", "tars2", .data = g[1])

    # Add a second dataset and then create a new scatterplot.
  g$setData(system.file("data", "sat.xml", package="Rggobi"), add=T)
  g$scatterplot("SAT", "RATIO", .data = g[2])  

   # The minimalist and unreadable invocation
  scatterplot.ggobi(c(1, 2))
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{setActiveColorScheme}
\alias{setActiveColorScheme}
\title{Specify the active color scheme in a GGobi or default.}
\description{
  This makes a particular color scheme active
  within a GGobi instance or sets the default active color scheme
   in the session options for use in new GGobi instances created after
   this call.
}
\usage{
setActiveColorScheme(id, .gobi=NULL)
}
\arguments{
  \item{id}{an identifier for the desired color scheme
    that is to be made active. This is usually the name of the
    scheme. Alternatively it can be an integer value that
    specifies the scheme by index in the list of color schemes.}
  \item{.gobi}{ the GGobi instance to which this scheme is to be active,
    or if \code{NULL}, sets it in the GGobi session options.
    In this case, the subsequently created GGobi instances will use this
    value as their initial color scheme.}
}
\value{
  The name of the previously active color scheme.
  This can be used to restore the previous setting.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
  \code{\link{addColorScheme}}
  \code{\link{getColorSchemes}}  
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"))
  schemes <- getColorSchemes(.gobi = g)
  setActiveColorScheme(names(schemes)[1], g)
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{setActivePlot.ggobi}
\alias{setActivePlot.ggobi}
\alias{getActivePlot.ggobi}
\title{Queries or sets the active ggobi plot.}
\description{
 These functions allow one to programmatically
determine which ggobi plot is ``active''. 
The active plot is the one in which the brushing
tool, point identification, etc. operate.
}
\usage{
setActivePlot.ggobi(display, plot=1, .gobi=getDefaultGGobi())
getActivePlot.ggobi(.gobi=getDefaultGGobi())
}
\arguments{
  \item{display}{the display which is to be made active and in which the 
    plot that is to get the focus of all subsequent operations resides.}
  \item{plot}{the integer identifying the plot within the display that is to be made active.}
  \item{.gobi}{the ggobi instance whose active plot is being queried or set,
   in which case it identifies the display. This should be an object of class
  \code{ggobi}.}
}
\value{
 Currently, an integer vector identifying the display
and plot that is, in the case of \code{getActivePlot.ggobi}, currently active 
and in the case of \code{getActivePlot.ggobi}, was active before that call.
This allows one to restore existing settings.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}
\seealso{
\code{\link{getDisplays.ggobi}}
\code{\link{getPlotCount.ggobi}}
\code{\link{getPlotType.ggobi}}
\code{\link{ggobi}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  g$scatmat(1:3)

    # Now set the 5 plot in the 3x3 matrix
    # (i.e. the middle one) in the second display
    # to be active.
  g$setActivePlot(2, 5)

  g$setMode("Brush")


   # create a new plot and ensure that the active
   # plot was as it was before the plot was created.

      # get the currently active plot
 old <- getActivePlot.ggobi()
      # create a new plot which then becomes active.
 scatmat.ggobi("tars1", "tars2")
      # restore the previous plot as being the active one.
 setActivePlot.ggobi(old, .gobi = g)
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{setData.ggobi}
\alias{setData.ggobi}
\alias{getData.ggobi}
\title{Load or retrieve a ggobi dataset.}
\description{
\code{getData.ggobi} retrieves the contents of a ggobi dataset
as an S matrix
and  \code{setData.ggobi} adds or replaces
a dataset either from a file or from an R matrix
or data frame.
}
\usage{
setData.ggobi(data, ..., .gobi=getDefaultGGobi())
getData.ggobi(.data = 1, .gobi=getDefaultGGobi())
}
\arguments{
  \item{data}{the name of a file or URL from which to load data
   or an S data frame or matrix containing the data.}
  \item{.gobi}{the ggobi instance into which or from which 
   the data should be added or retrieved. }
  \item{.data}{an identifier for the dataset of interest with the GGobi instance.
   This is either a name, an integer index or a reference to a GGobi dataset of
   class \code{ggobiDataset}}
  \item{...}{passed to \code{\link{setDataFile.ggobi}}}
}
\value{
 \code{getData.ggobi}
 returns a matrix containing the values
 in the specified ggobi dataset, using
 its row labels as row names and variable names
 as column names.

 \code{setData.ggobi} returns an object of class
 \code{ggobiDataset} that provides a convenient
 reference to the internal ggobi dataset. 
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}


\seealso{
\code{\link{setDataFrame.ggobi}}
\code{\link{setDataFile.ggobi}}
}

\examples{
  g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
  data(mtcars)
  setData.ggobi(mtcars)

  getData.ggobi(g[1])
  g[[1]][,1]
}
\keyword{visualization}

\eof
\name{setDataFile.ggobi}
\alias{setDataFile.ggobi}
\title{Load data from a file into a ggobi instance}
\description{
 This replaces the existing data in the specified ggobi instance
with the dataset(s) in the file given by name.
}
\usage{
setDataFile.ggobi(file, mode="unknown", add = T, .gobi=getDefaultGGobi())
}
\arguments{
  \item{file}{the name of the file from which to read the data.
   Note that if XML support has been compiled for ggobi, this can be a
   compressed file or even a URL.}
  \item{mode}{this indicates which format to expect the data to be in. This is
 optional and if not supplied, the ggobi system attempts to find the file 
 by looking through different extensions and checking the contents for a valid data stream.
 This helps to avoid loading data unitentionally due to name conflicts.
 }
  \item{add}{a logical value indicating whether to add the newly loaded dataset
  to the existing collection of data sets, or simply to replace them.}
  \item{.gobi}{the ggobi instance into which the new data should be loaded.
  This is needed only if there are multiple ggobi instances and the
  target is not the currently active/default instance.}
}
\details{
 This re-initializes the ggobi instance, discarding the existing
data and plots, and creating the default starting view.
}
\value{
 a logical value indicating whether the load was successful. \\
 In the future, this might be a dataset description.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{ggobi}}
\code{\link{setDataFrame.ggobi}}
\code{\link{getFileNames.ggobi}}
}

\examples{
 setDataFile.ggobi(system.file("data", "flea.xml", package="RSggobi"))
 setData.ggobi(system.file("data", "flea.xml", package="RSggobi"))

\dontrun{
 setData.ggobi("http://www.ggobi.org/data/flea.xml")
}
}
\keyword{visualization}

\eof
\name{setDataFrame.ggobi}
\alias{setDataFrame.ggobi}
\title{Sets the data for a ggobi instance from a data frame.}
\description{
 This sets the variables being displayed by the ggobi instance
to the columns in the specified data frame, using all its
rows as records. This allows one to create data dynamically
in R and not write it to a file to have ggobi display it.
}
\usage{
setDataFrame.ggobi(data, name= description, description =
deparse(sys.call()[[2]]), add=TRUE, id = TRUE, .gobi=getDefaultGGobi())
}
\arguments{
  \item{data}{the data frame (rectangular ``table'' of values) to use in
    the ggobi displays. The values are converted to real/numeric values
    and can now contain NAs which are `missing' in GGobi.
    }
  \item{name}{the name by which to refer to this dataset and identify it in the variable panel by tab name.}
  \item{description}{a description of the data for use in window titles
    and }
  \item{add}{a logical value indicating whether to append this newly loaded dataset
  to the existing collection (\code{TRUE}), or to replace that collection with this
  one dataset (\code{FALSE}).}
  \item{id}{identifiers for the particular records to be set. By
    default, this applies to the first n observations.}
  \item{.gobi}{the ggobi instance whose data is to be replaced with those in the data frame.}
}
\details{
This discard all the existing plots and data sets in the ggobi instance
and re-initializes it with the new data.

Since ggobi now supports multiple data sets within a ggobi instance,
in the near future, we will provide an option to add this data frame
as a data source in the ggobi instance.
}
\value{
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{ggobi}}
\code{\link{setData.ggobi}}
\code{\link{setDataFile.ggobi}}
}

\examples{
 data(mtcars)
 g <- ggobi(mtcars)
 setDataFrame.ggobi(mtcars, .gobi = g)

  # Put a missing value in the dataset
 mtcars[1, 1] <- NA
  # Now load it
 g <- ggobi(mtcars)

  # Now retrieve the dataset and verify the
  # the NA is in the result from GGobi.
 g[[1]][,]
}
\keyword{visualization}
\keyword{graphics}

\eof
\name{setDisplayEdges.ggobi}
\alias{setDisplayEdges.ggobi}
\title{Associate an edge set with a GGobi display}
\description{
 This sets the edges associated with 
 one or more GGobi displays and its plots.
 The user can specify
 whether the edges should be drawn as directed or undirected
 segments.
}
\usage{
setDisplayEdges.ggobi(displays, edgeData, directed=FALSE, .gobi=getDefaultGGobi())
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{displays}{a list of \code{ggobiDisplay} objects
    which are to be changed to have  the specified edge set
    (\code{edgeData}) be the associations between the points.}
  \item{edgeData}{the dataset providing the edges/connections pairs}
  \item{directed}{a logical value indicating whether the edges
   should be displayed as directed line segments or simple lines.}
 \item{.gobi}{the GGobi instance in which to find the
   displays. This is needed if \code{displays} is specified
   using indices  rather than \code{ggobiDisplay} objects.
 }
}
\details{

}
\value{
  A list with the same number of elements
  as displays passed to this function.
  Each element contains a reference to the
  GGobi dataset that was used for edges
  for the display, or NULL if no edges
  were used.
}
\references{
\url{http://www.ggobi.org/RSggobi}
\url{http://www.ggobi.org}
}
\author{
Duncan Temple Lang
}
\note{
The edge mechanism in GGobi is general and powerful
and can be difficult to understand 
and can be slightly counter-intuitive for
simple cases. 
}

\seealso{
\code{\link{createEdgeData.ggobi}}
\code{\link{getEdges.ggobi}}
\code{\link{setEdges.ggobi}}
}

\examples{

}
\keyword{dynamic}

\eof
\name{setDisplayOptions.ggobi}
\alias{setDisplayOptions.ggobi}
\alias{getDisplayOptions.ggobi}
\title{Controls the basic display settings for ggobi}
\description{
 This allows one to set the settings that control
how ggobi displays its plots.
These have effect on all plots created after the settings
have been registered, and are not applied to existing plots.
}
\usage{
getDisplayOptions.ggobi(which=1, .gobi=getDefaultGGobi())
setDisplayOptions.ggobi(points, directed, undirected, segments, missings, axes, display, .gobi=getDefaultGGobi())
}
\arguments{
  \item{which}{the identifier for the display of interest, either an index
   or a \code{ggobiDisplay} object.}
  \item{display}{the display identifier, either an integer giving the index in the list of displays
   within the GGobi instance, or an object of class \code{ggobiDisplay}}
  \item{points}{logical value indicating whether points are to be displayed on a plot.}
  \item{directed}{logical value indicating whether the line segments are to be shown as directed 
(TRUE) or undirected (FALSE) line segments.}
  \item{undirected}{}
  \item{segments}{}
  \item{missings}{}
  \item{axes}{whether axes should be displayed with the plot or not.}
  \item{.gobi}{the ggobi instance for which the settings are to be applied.}
}

\value{
 The previous settings that were in effect 
before this call.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
 \code{\link{getDisplayOptions.ggobi}}
}

\examples{
 # untested

 data(mtcars)
 ggobi(mtcars)

 old <- setDisplayOptions.ggobi(axes=FALSE)
 scatterplot.ggobi("mpg", "am")

   # restore the old settings.
 setDisplayOptions.ggobi(old)
}
\keyword{visualization}

\eof
\name{setDisplayWidth.ggobi}
\alias{setDisplayWidth.ggobi}
\alias{getDisplayWidth.ggobi}
\title{Controls the size of a ggobi display window}
\description{
 On occassion, it is convenient  to be able to programmatically
 change the size of a window housing a ggobi display.
 This function attempts to allow one to do this.
 Unfortunately, it doesn't seem to have any effect.
}
\usage{
setDisplayWidth.ggobi(sz, display=1, .gobi=getDefaultGGobi())
getDisplayWidth.ggobi(display=1, .gobi=getDefaultGGobi())
}
\arguments{
  \item{sz}{a vector giving the width and height to which 
    the dimensions of the display window should be set.}
  \item{display}{an identifier for the particular display within the ggobi instance.
   This can be either an object of class \code{ggobiDisplay}
   or an integer.}
  \item{.gobi}{the ggobi instance in which to resolve the \code{display}.
     This can be an object of class \code{ggobi} or an integer identifying
    it by position in the list returned by \code{\link{getGGobi}}.}
}
\details{
  This attempts to set the dimensions of the Gnome window.
}
\value{
 The return value of these two functions
 is an integer vector containing the
 dimension (width and height) of the
 window before this function was called.
 In the case of \code{setDisplayWidth.ggobi},
 this value is the old setting.

 At present, these return \code{c(0,0)}.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{ 
 The plot creation functions
 \code{\link{scatmat.ggobi}},
 \code{\link{scatterplot.ggobi}}
 \code{\link{parcoords.ggobi}}.
}

\examples{
    g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
    g$setDisplayWidth(c(200, 300), 1)
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{setIdentifyHandler.ggobi}
\alias{setIdentifyHandler.ggobi}
\title{Register callback for ggobi point identification}
\description{
This function  is an example of how we can link R
commands into ggobi and have ggobi ``notify''
R of certain events. 
This  example allows us to register an R function
that is called each time an observation is selected
in ggobi's ``identify'' mode, i.e. when the label appears
over the point. This R function is given information
about the point being identified,
a description of the display in which the identification
is being performed, and  the index of the active plot.
This gives a programmatic version of \code{\link{locator}}.
}
\usage{
setIdentifyHandler.ggobi(f, .gobi=getDefaultGGobi())
}
\arguments{
  \item{f}{the function to be invoked when 
    an observation is identified by the interactive ggobi
   selection/identification mechanism.
  This currently should take two arguments which are 
  the index of the observation just identified, and the
  display object (of class \code{ggobiDisplay}) which identifies the 
  window and ggobi instance in which the identification was made.}
  \item{.gobi}{the ggobi instance with which the function should be registered
   and within which identification of a record triggers the callback.}
}
\details{
 This is just an illustration of how we can connect
the functionality in the two environments (R and ggobi).
We can add other function callbacks and event notifications
to provide more interactivity at the R level.
}
\value{
The previously registered value of 
this callback function.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}
\seealso{
\code{\link{setSmootherFunction.ggobi}}
\code{\link{locator}}
}

\examples{
 f <- function(id, display) {
    print(id)
    print(display)
 }
 g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
 g$setIdentifyHandler(f)
 g$setMode("Identify")
  # now move the mouse over some of the points
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{setPlotRange.ggobi}
\alias{setPlotRange.ggobi}
\alias{getPlotRange.ggobi}
\title{Set the axes ranges of a ggobi plot.}
\description{
 These functions are intended to 
allow the R programmer and user to 
query and set the range of the plot in the
units of the variables (rather than pixels).
This currently is not implemented.
}
\usage{
setPlotRange.ggobi(x, y, plot=1, display = 1, .gobi=getDefaultGGobi())
getPlotRange.ggobi(plot=1, display = 1, .gobi=getDefaultGGobi())
}
\arguments{
  \item{x}{a numeric vector of length 2 specifying
       the minimum and maximum values for the X axis.}
  \item{y}{a numeric vector of length 2 specifying
       the minimum and maximum values for the Y axis.}
  \item{plot}{an integer identifying which of the plots
     is to be queried or modified.}
  \item{display}{an identifier for which of the display windows
   the plot is contained. }
  \item{.gobi}{an identifier for the ggobi instance which owns the
    display and plot.}
}
\value{
 A list of length 2, with each element
being a numeric vector of length 2 giving the
minimum and maximum values for the corresponding
axis. The first element is the X axis, and the second
is the Y axis.
}

\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}


\seealso{
 \code{\link{scatmat.ggobi}}
 \code{\link{scatterplot.ggobi}}
 \code{\link{parcoords.ggobi}}
}

\examples{

}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{setPlotVariables.ggobi}
\alias{setPlotVariables.ggobi}
\title{Specify the variables in a ggobi plot}
\description{
 This allows the caller to change the contents
 of a plot by specifying a different set of variables
 to render in the plot.
}
\usage{
setPlotVariables.ggobi(..., display=1, .gobi=getDefaultGGobi(), plots=NULL)
}
\arguments{
  \item{\dots}{identifiers for the variables 
         that are to be used in the specified plot. These can be names or integers.}
  \item{display}{the display or plot window in the ggobi instance in 
   which the plot to affected  can be found.}
  \item{.gobi}{an identifier for the ggobi instance in which the display
    is to be found.}
  \item{plots}{an optional argument identifying the sub-plot within the 
   display whose variables are to be changed.
   This is optional as in certain cases, there is no need to specify the plot. }
}
\value{
 the names and indices of the variables that were in this
plot before we reset them.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}
\seealso{
 \code{\link{getDisplays.ggobi}}
}

\examples{
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{setRowNames.ggobi}

\alias{setRowNames.ggobi}
\alias{getRowNames.ggobi}
\title{Set or retrieve record labels.}
\description{
 Set or retrieve the names of records in a ggobi dataset.
}
\usage{
setRowNames.ggobi(names, ids=1:length(names), .data = 1, .gobi=getDefaultGGobi())
getRowNames.ggobi(.data = 1, .gobi=getDefaultGGobi())
}
\arguments{
  \item{names}{the names to assign to the records identified by \code{ids}.
This is a character vector.}
  \item{ids}{an integer vector providing the indices of the records
 for which the \code{names} are to be assigned.}
  \item{.data}{the dataset to which these assignments or retrieval
should be applied.  This is an integer identifying to which of the
datasets to query or apply the assignment.  These start at $1$ (rather
than $0$).}
  \item{.gobi}{the ggobi instance to which these operations should be applied.}
}
\details{
 Each record in a dataset in ggobi has an associated label
or name. These functions allow the user to query these or
assign values to a subset of them.
}
\value{
 \code{getRowNames} returns a character vector 
 containing the curent values for all of the 
 records in the specified dataset within the ggobi instance.
\\
 \code{setRowNames} returns the previous names/labels of the 
specified records.
}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
\code{\link{setDataFile.ggobi}}
\code{\link{setDataFrame.ggobi}}
}

\examples{

}
\keyword{visualization}
\keyword{graphics}

\eof
\name{setVariableValues.ggobi}
\alias{setVariableValues.ggobi}
\alias{setVariableName.ggobi}
\title{Set variable information in a ggobi dataset.}
\description{
 These functions allow one to set the values or name of
one or more variables within a ggobi dataset.
}
\usage{
setVariableValues.ggobi(values, var, rows = 1:length(values), update = T, .data = 1, .gobi=getDefaultGGobi())
setVariableNames.ggobi(..., .data = 1, .gobi=getDefaultGGobi())
}
\arguments{
  \item{values}{a numeric vector of values which are to be used
    as the values for the specified variable.}
  \item{var}{an identifier for the variable whose values are to be
    replaced with those in \code{values}. This can be either a
   name or alternatively an integer identifying the variable by index.}
  \item{rows}{the indices of the rows whose values are to be set.
    The i-th element of values becomes the value
    of the rows[i] element of the specified variable.}
  \item{update}{whether to update the displays after setting the values.
  Typicaly this is TRUE. However, if one wanted to set values
  for other variables after this, one can delay the update operation
  until all changes are complete.}
  \item{\dots}{a collection of named string arguments
     of the form \code{existingName = newName}
     specifying the mapping from an existing name to
     the new name that is to replace it.
    }
  \item{.data}{the identifier for the dataset in which the variable(s) reside.}
  \item{.gobi}{the ggobi instance.}
}
\value{
\code{setVariableNames.ggobi} returns the previous settings
for the names of those variables that were modified.

\code{setVariableValues.ggobi} returns the previous values for the
records/observations in the specified variable.

}
\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\note{\code{setVariable.ggobi} and \code{setVariableValues.ggobi}
appear to be very similar. That probably means that a) one will disappear
and b) one is not tested as comprehensively as the other.}

\seealso{
\code{\link{setDataFrame.ggobi}}
\code{\link{names.ggobiDataset}}
\code{\link{getVariable.ggobi}}
}

\examples{
 g <- ggobi(system.file("data", "flea.xml", package="Rggobi"), args="-noinit")
 g$setVariableNames(tars1="New name", aede1="Other name")

   # Set all the values of the tars1 variable to `1'.
 g$setVariableValues(rep(1, 74), rows = 1:74, var = "tars1")

   # Set the first 23 values. 
 g$setVariableValues(rnorm(23), var = "tars1")


}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{writeDataXML}
\alias{writeDataXML}
\title{Write one or more datasets in GGobi's XML format}
\description{
  This creates an XML output object (to a buffer, DOM, ...)
  containing a description of a collection of datasets
  using GGobi's data format.
}
\usage{
writeDataXML(..., dom = xmlOutputDOM("ggobidata", attrs = c(count = length(args))))
}

\arguments{
  \item{\dots}{one or more datasets, typically given as
    \code{name=object} so that the `name' is used in the XML
    description.
  }
  \item{dom}{the XML output object to which to write/append the XML
    description. This is usuall an object of class \code{XMLOutputStream}}
}
\details{
  The GGobi data format is described in the GGobi documentation
  and may be used in other projects and contexts.
  It is reasonably simply, consisting of a top-level
  \code{ggobidata} node with an (optional) attribute indicating the
  number of datasets it contains, and then each dataset described as
  sub-nodes. Each dataset consists of a top-level \code{data} node
  with \code{name} attribute. Within this, we have
  an optional \code{description} node giving a human-readable
  description of the dataset, where it came from, etc.
  Next is a \code{variables} node which details each of the variables,
  giving its type (currently either as a \code{realvariable}
  or \code{categoricalvariable}) and any other information, such
  as its name and its levels.
  
}
\value{
  The \code{dom} object is returned, presumably with its state
  changed to include the XML for the datasets.
}

\references{\url{http://www.ggobi.org}}
\author{Duncan Temple Lang}

\seealso{
  \code{addXMLDataset}
}

\examples{
 data(mtcars)
 dd <- writeXMLData(mtcars = mtcars)
 cat(dd$value())
}
\keyword{visualization}
\keyword{interactive graphics}

\eof
\name{xmlColorSchemeHandlers}
\alias{xmlColorSchemeHandlers}
\title{Functions for processing XML color scheme input}
\description{
  This returns a collection of functions that share and update
  a common set of variables and which process the nodes in an XML
  input source to extract information about color schemes
  and create R objects to represent the schemes.
}
\usage{
xmlColorSchemeHandlers()
}
\details{
 These handlers are passed to \code{\link[XML]{xmlTreeParse}}.
}
\value{
  A list of functions.
  \item{colormap}{a function for processing the \code{colormap} node
    by iterating over its sub-nodes and adding
    an entry to the \code{schemes} variable.}
  \item{getData}{function to access the \code{schemes} list
   after the processing is complete.}
}

\references{\url{http://www.ggobi.org}
  \url{http://www.ggobi.org/RSggobi}
}
\author{Duncan Temple Lang}
\seealso{
\code{\link{readXMLColorSchemes}}
}

\examples{

}
\keyword{visualization}
\keyword{interactive graphics}

\eof
